#include <stdio.h>
#include "3dtypes.h"
extern object obj[];
extern void make_palette(struct pal *pal);
extern int avertices,afaces,maxobj,using_memory,maxtex,maxpal;
/**/
int backface(f3d *f,p2d *sc)
{
  int a,b,c;

  float nul;

  a=f->a;
  b=f->b;
  c=f->c;

  nul = (sc[a].x - sc[c].x) * (sc[b].y - sc[c].y)-
        (sc[b].x - sc[c].x) * (sc[a].y - sc[c].y);

  if (nul<0.0)
    return 0;
  else
    return 1;

}
/**/
int load_3dg(char *file_name)
{

  FILE *f;
  int i,j;
  v3d *v;
  f3d *w;

  avertices=0;
  afaces=0;
  using_memory=0;



  f=fopen(file_name,"rb");
  if (f==NULL) return -1;

  fread(&maxobj,sizeof(int),1,f);


  for (i=0;i<maxobj;i++)
  {

      fread(&obj[i].vertices,sizeof(int),1,f);
      fread(&obj[i].faces,sizeof(int),1,f);

      obj[i].v   = (v3d *) calloc(obj[i].vertices,sizeof(v3d));
      obj[i].n2v = (v3d *) calloc(obj[i].vertices,sizeof(v3d));
      obj[i].n2f = (v3d *) calloc(obj[i].faces,sizeof(v3d));
      obj[i].wr  = (f3d *) calloc(obj[i].faces,sizeof(f3d));
      obj[i].sc  = (p2d *) calloc(obj[i].vertices,sizeof(p2d));
/**/  obj[i].uv  = (v3d *) calloc(obj[i].vertices,sizeof(v3d));

      v=obj[i].v;
      for (j=0;j<obj[i].vertices;j++)
        {
         fread(v,sizeof(float)*3,1,f);
         v++;
        }
      w=obj[i].wr;
      for (j=0;j<obj[i].faces;j++)
        {
         fread(w,sizeof(int)*3,1,f);

//         if (backface

         w++;
        }
//      fread(obj[i].v,sizeof(v3d),obj[i].vertices,f);
//      fread(obj[i].wr,sizeof(f3d),obj[i].faces,f);


      avertices+=obj[i].vertices;
      afaces+=obj[i].faces;

      obj[i].st=0;
      obj[i].p=0;
      obj[i].t=0;

  }


  return 0;

}
/**/
int load_3dg_2_0(char *file_name)
{

  FILE *f;
  int i,j;
  char id[14];

  v3d *v;
  f3d *w;

  avertices=0;
  afaces=0;
  using_memory=0;

  f=fopen(file_name,"rb");
  if (f==NULL) return -1;

  fread(id,14,1,f);

  if (strcmp(id,"3DG FILE V.2.0")!=0)
    {
      fclose(f);
      return -2;
    }

  fread(&maxobj,sizeof(int),1,f);
  fread(&maxpal,sizeof(int),1,f);
  fread(&maxtex,sizeof(int),1,f);


  for (i=0;i<maxobj;i++)
  {

      fread(&obj[i].vertices,sizeof(int),1,f);
      fread(&obj[i].faces,sizeof(int),1,f);
      fread(&obj[i].st,sizeof(int),1,f);
      fread(&obj[i].p,sizeof(int),1,f);
      fread(&obj[i].t,sizeof(int),1,f);

      obj[i].v   = (v3d *) calloc(obj[i].vertices,sizeof(v3d));
      obj[i].n2v = (v3d *) calloc(obj[i].vertices,sizeof(v3d));
      obj[i].n2f = (v3d *) calloc(obj[i].faces,sizeof(v3d));
      obj[i].wr  = (f3d *) calloc(obj[i].faces,sizeof(f3d));
      obj[i].sc  = (p2d *) calloc(obj[i].vertices,sizeof(p2d));
/**/  obj[i].uv  = (v3d *) calloc(obj[i].vertices,sizeof(v3d));

      v=obj[i].v;
      for (j=0;j<obj[i].vertices;j++)
        {
         fread(v,sizeof(float)*3,1,f);
         v++;
        }
      w=obj[i].wr;
      for (j=0;j<obj[i].faces;j++)
        {
         fread(w,sizeof(int)*3,1,f);
         w++;
        }

//      fread(obj[i].v,sizeof(v3d),obj[i].vertices,f);
//      fread(obj[i].wr,sizeof(f3d),obj[i].faces,f);


      avertices+=obj[i].vertices;
      afaces+=obj[i].faces;

  }

  for (i=0;i<maxpal;i++)

    {
      fread(&palette[i].r,sizeof(int),1,f);
      fread(&palette[i].g,sizeof(int),1,f);
      fread(&palette[i].b,sizeof(int),1,f);
      fread(&palette[i].l,sizeof(int),1,f);

      make_palette(&palette[i]);
    }

  for (i=0;i<maxtex;i++)

    fread(texture[i].filename,sizeof(char),8+3+1,f);

  return 0;
}
/**/
void save_3dg(char *file_name)
{
  FILE *f;
  int i,j;
  v3d *v;
  f3d *w;

  char *id="3DG FILE V.2.0";

  f=fopen(file_name,"wb");
  fwrite(id,14,1,f);

  j=maxobj;
  for (i=0;i<maxobj;i++) if (obj[i].hide==1) j--;


  fwrite(&j     ,sizeof(maxobj),1,f);
  fwrite(&maxpal,sizeof(maxpal),1,f);
  fwrite(&maxtex,sizeof(maxtex),1,f);

  for (i=0;i<maxobj;i++)
  if (obj[i].hide==0)

    {
      fwrite(&obj[i].vertices,sizeof(int),1,f);
      fwrite(&obj[i].faces,sizeof(int),1,f);
      fwrite(&obj[i].st,sizeof(int),1,f);
      fwrite(&obj[i].p,sizeof(int),1,f);
      fwrite(&obj[i].t,sizeof(int),1,f);

      v=obj[i].v;
      for (j=0;j<obj[i].vertices;j++)
        {
         fwrite(v,sizeof(float)*3,1,f);
         v++;
        }
      w=obj[i].wr;
      for (j=0;j<obj[i].faces;j++)
        {
         fwrite(w,sizeof(int)*3,1,f);
         w++;
        }

//      fwrite(obj[i].v,sizeof(v3d),obj[i].vertices,f);
//      fwrite(obj[i].wr,sizeof(f3d),obj[i].faces,f);

    }

  for (i=0;i<maxpal;i++)

    {
      fwrite(&palette[i].r,sizeof(int),1,f);
      fwrite(&palette[i].g,sizeof(int),1,f);
      fwrite(&palette[i].b,sizeof(int),1,f);
      fwrite(&palette[i].l,sizeof(int),1,f);

    }

  for (i=0;i<maxtex;i++)
    fwrite(texture[i].filename,sizeof(char),8+3+1,f);

  fclose(f);


}
/**/
