/*
   3D from DGS CO'96 (The Newcomers)
   Code by HERN
   3DGS v.2.1.a (in GNU C)
*/


#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include <dpmi.h>
#include <go32.h>
#include <kb2.h>
#include <time.h>
#include <strings.h>
#include "3dtypes.h"
#include "gfx.h"

#define ALPHA (1.5*PI/180.0)

#define FT_GOURAUD 0
#define FT_TEXTURE 1
#define FT_PHONG   2
#define FT_FLAT    3


#define ABS(x) ((x)>=0?(x):(-(x)))

#define STOSL(dest, val, numwords) \
__asm__ __volatile__ ( \
  "rep\n\t" \
  "stosl" \
  : : "D" (dest), "c" (numwords) ,"a" (val) \
  : "%ecx", "%esi", "%edi" )


#define MOVSL(dest, src, numwords) \
__asm__ __volatile__ ( \
  "rep\n\t" \
  "movsl" \
  : : "D" (dest), "c" (numwords) ,"S" (src) \
  : "%ecx", "%esi", "%edi" )



#define STOSW1(dest, val) \
__asm__ __volatile__ ( \
  "addl %%ebx,%%edi;" \
  "movw %%ax,(%%edi);" \
  : : "D" (scr), "b" (dest<<1), "a" (val) \
  : "%ecx", "%esi", "%edi" )


#define WHITE COL15(0xff,0xff,0xff)
#define GREEN COL15(0,127,90)
#define LGREEN COL15(0,255,0)

object obj[100];

extern int aedges;
int edges_c;

static t2d    v_arr[12];
static t2df   vx[12];

int sx,sy;


int    i,j;
float  ob,ob_step;
float  perspective=400.0;
int    frames;


int    a,b,c;
char   s[255]="";

char *scr;
int  *zbuff;
char *bkg,*bbkg;

int maxtex;
int maxpal;

int VBL_F=0;
int ALL_FACES_F=0;
int FPS_F=0;
int SHOW_BMP_F=0;
int WIREFRAME_F=0;
int CHANGE_VIEW_F=0;
int ZBUFF_F=0;
int TEXTURE_F=0;
int GOURAUD_F=1;
int REDRAW_F=1;
int SELECT_F=0;
int FRAMESKIP_F=0;
int TEXTURE_GOURAUD_LIGHT=0;
int TEXTURE_PHONG_LIGHT=0;
int TEXTURE_NORMAL=1;
int TEXTURE_ENV=1;
int EDGES_F=0;

int xmin,xmax,ymin,ymax;

int n;
int maxobj;
int adr;
int obj_n;
float frameskip=30.0;

int  light[256];
char *light_phong_map;
char *texture_rgb;
char *background;

extern void sort(int n);
extern void calc_normals(void);
extern void calc_ob(void);
extern void center_object(void);
extern void calcp2(void);
extern void frot3(float alfax,float alfay);
extern void scale_object(float s);
extern void save_3dg(char *filename);
extern void draw_texture_triangle(t2df *va,char *texture);
extern void draw_texture_triangle_perspective(t2df *va,char *texture);
extern void draw_texture_triangle_perspective_f(t2df *va,char *texture);
extern void draw_gouraud_triangle(t2df *va,short *palette);
extern void draw_gouraud_triangle_zbuffer(t2df *va,short *pal);
extern void draw_texture_triangle_zbuffer(t2df *va,char *texture);
extern void draw_texture_phong_light_triangle(t2df *va,char *texture,char *light);
extern void draw_flat_triangle(t2df *va,int col);
extern void draw_flat_triangle_zbuffer(t2df *va,int col);
extern void draw_small_texture(char *texture,int x,int y,int w,int h);
extern void make_palette(struct pal *pal);
extern void display_local_menu(void);
extern void make_gouraud_light(int l,int maxl);
extern void make_phong_light(int maxl);
extern void make_background(int maxl);
extern void make_rgb_texture(char *img);
extern void copyb15(char *src,char *dst,int x,int y,int w,int h);
//extern void line2(char *img,float x1, float y1, float x2, float y2, int col);
extern void make_phong(int maxl,short *phong);

float alphax,alphay;
float lx,ly,lz;
float aspectratio;


int textp_vbl;
int textp_zbuffer;
int textp_frameskip;

/**/
void dfree(void *mem)
{
  if (mem)
    free(mem);
}
/**/
inline STOS(int dest,int val,int numwords)
{
 asm (

      "
      movl %%eax,%%ebx
      shll $16,%%eax
      movw %%bx,%%ax
      movl %%ecx,%%ebx
      shrl $1,%%ecx
      shll $1,%%ecx
      subl %%ecx,%%ebx
      shrl $1,%%ecx
      rep; stosl
      cmpl $0,%%ebx
      jz   0f
      stosw

   0:
      "
  :
  : "D" (scr+dest*2), "c" (numwords), "a" (val)
  : "eax", "ebx", "ecx", "edi"
 );
}
/**/
void clean(char *ptr,int val)
{
  int i;
  char *adr;
  ymax++;
  if (xmin<0) xmin=0;
  if (xmax>screen_w) xmax=screen_w;
  if (ymin<0) ymin=0;
  if (ymax>screen_h) ymax=screen_h;

  adr=ptr+(xmin+ymin*screen_w)*2;
  for (i=ymin;i<ymax;i++)
    {
      STOSL(adr,val,((xmax-xmin)>>1)+1);
      adr+=screen_w*2;
    }

}
void move(char *ptr0,char *ptr1)
{
  int i;
  int adr;
  if (xmin<0) xmin=0;
  if (xmax>screen_w) xmax=screen_w;
  if (ymin<0) ymin=0;
  if (ymax>screen_h) ymax=screen_h;

  adr=(xmin+ymin*screen_w)*2;
  for (i=ymin;i<ymax;i++)
    {
      MOVSL(ptr0+adr,ptr1+adr,((xmax-xmin)>>1)+1);
      adr+=screen_w*2;
    }

}
/**/
void sortq(const int l,const int r)
{
  int i,j;
  register int x;

  i=l;
  j=r;
  x=dr[(l+r) >> 1].z;
  do {
    while (dr[i].z<x) i++;
    while (x<dr[j].z) j--;
    if (i<=j)
    {
      asm (
      "
        movl (%%edi),%%eax;
        movl (%%esi),%%ebx;
        movl %%eax,(%%esi);
        movl %%ebx,(%%edi);

        addl $4,%%edi;
        addl $4,%%esi;

        movl (%%edi),%%eax;
        movl (%%esi),%%ebx;
        movl %%eax,(%%esi);
        movl %%ebx,(%%edi);

        addl $4,%%edi;
        addl $4,%%esi;

        movl (%%edi),%%eax;
        movl (%%esi),%%ebx;
        movl %%eax,(%%esi);
        movl %%ebx,(%%edi);
      "

      :
      : "D" (&dr[i]),"S" (&dr[j])
      : "%eax", "%esi", "%edi","%ebx"

      );

      i++;
      j--;
    }
  }
  while (i<j);
  if (l<j) sortq(l,j);
  if (i<r) sortq(i,r);
}

void quicksort(int max)
{
  sortq(0,max-1);
}

/**/
void draw_objects()
{
  int i,j,n,num,col,k;
  int p;
  double nul;
  int a,b,c,l0,l1,l2;
  int over_ob;
  int w;

  float x,y,z,g,gg;

  l2d *l;
  int s,e;

  t2df t;


  int x1,x2,y1,y2;



  p=0;
  nul=-1;
  over_ob=0;

  for (n=0;n<maxobj;n++)
    {

       sc=obj[n].sc;
       wr=obj[n].wr;
       v=obj[n].v;
       l=obj[n].l;

//       for (i=0;i<obj[n].edges;i++) l[i].drawn=0;


       for (i=0;i<obj[n].faces;i++)
         {

           a=wr[i].a;
           b=wr[i].b;
           c=wr[i].c;
/*

           nul=v[c].x*(v[a].z*v[b].y-v[a].y*v[b].z)+
               v[c].y*(v[a].x*v[b].z-v[a].z*v[b].x)+
               v[c].z*(v[a].y*v[b].x-v[a].x*v[b].y);*/


           nul = (sc[a].x - sc[c].x) * (sc[b].y - sc[c].y)-
                 (sc[b].x - sc[c].x) * (sc[a].y - sc[c].y);

//           nul=dot(i);



           if (CHANGE_VIEW_F) nul=-nul;

           if (ALL_FACES_F) nul=1;


           if (

               v[a].z<-ob &&
               v[b].z<-ob &&
               v[c].z<-ob

               )

           {
             wr[i].null=1;
             if (nul>=0)
               {
                  dr[p].z=(int)(v[a].z+v[b].z+v[c].z);
                  dr[p].num=i;
                  dr[p].n=n;
//                  drp[p]=&dr[p];
                  p++;

               }
             else wr[i].null=0;
           }
         }
    }

  if (!ZBUFF_F && !WIREFRAME_F) quicksort(p);

/*
  if (WIREFRAME_F)
    {
      for (n=0;n<maxobj;n++)
        {
          l=obj[n].l;
          wr=obj[n].wr;
          sc=obj[n].sc;

          for (i=0;i<obj[n].edges;i++)
            if (wr[l[i].n].null)
              {

                s=l[i].s;
                e=l[i].e;


                line(scr,(int)sc[s].x,(int)sc[s].y,
                         (int)sc[e].x,(int)sc[e].y,WHITE);
              }

        }
    } else*/

  edges_c=0;

  n=dr[0].n;
  num=dr[0].num;
  a=wr[num].a;
//  xmin=xmax=obj[n].sc[a].x;
//  ymin=ymax=obj[n].sc[a].y;

  for (i=0;i<p;i++)
    {

      n=dr[i].n;

      sc=obj[n].sc;
      wr=obj[n].wr;
      v=obj[n].v;
      n2v=obj[n].n2v;
      n2f=obj[n].n2f;
      uv=obj[n].uv;

      num=dr[i].num;

      a=wr[num].a;
      b=wr[num].b;
      c=wr[num].c;

      l0=wr[num].l0;
      l1=wr[num].l1;
      l2=wr[num].l2;




      if (obj[n].hide==0 && !WIREFRAME_F)
        {
           vx[0].x=sc[a].x;
           vx[0].y=sc[a].y;
           vx[1].x=sc[b].x;
           vx[1].y=sc[b].y;
           vx[2].x=sc[c].x;
           vx[2].y=sc[c].y;

/*
           if (sc[a].x>xmax) xmax=sc[a].x;
             else
           if (sc[a].x<xmin) xmin=sc[a].x;

           if (sc[b].x>xmax) xmax=sc[b].x;
             else
           if (sc[b].x<xmin) xmin=sc[b].x;

           if (sc[c].x>xmax) xmax=sc[c].x;
             else
           if (sc[c].x<xmin) xmin=sc[c].x;

           if (sc[a].y>ymax) ymax=sc[a].y;
             else
           if (sc[a].y<ymin) ymin=sc[a].y;

           if (sc[b].y>ymax) ymax=sc[b].y;
             else
           if (sc[b].y<ymin) ymin=sc[b].y;

           if (sc[c].y>ymax) ymax=sc[c].y;
             else
           if (sc[c].y<ymin) ymin=sc[c].y;*/

           if (TEXTURE_ENV)
             {
                vx[0].u=n2v[a].x+127.0;
                vx[0].v=n2v[a].y+127.0;
                vx[1].u=n2v[b].x+127.0;
                vx[1].v=n2v[b].y+127.0;
                vx[2].u=n2v[c].x+127.0;
                vx[2].v=n2v[c].y+127.0;

             } else
             {
                vx[0].u=uv[a].x+127.0;
                vx[0].v=uv[a].y+127.0;
                vx[1].u=uv[b].x+127.0;
                vx[1].v=uv[b].y+127.0;
                vx[2].u=uv[c].x+127.0;
                vx[2].v=uv[c].y+127.0;
             }

           if (TEXTURE_PHONG_LIGHT)
             {
                vx[0].ul=n2v[a].x+127.0;
                vx[0].vl=n2v[a].y+127.0;
                vx[1].ul=n2v[b].x+127.0;
                vx[1].vl=n2v[b].y+127.0;
                vx[2].ul=n2v[c].x+127.0;
                vx[2].vl=n2v[c].y+127.0;
             }
           if (TEXTURE_GOURAUD_LIGHT || obj[n].st==FT_GOURAUD)
             {
                vx[0].l=ABS(n2v[a].z)*2.0;
                vx[1].l=ABS(n2v[b].z)*2.0;
                vx[2].l=ABS(n2v[c].z)*2.0;
             }
           if (ZBUFF_F)
             {
                vx[0].z=v[a].z;
                vx[1].z=v[b].z;
                vx[2].z=v[c].z;
             }

           nul = (sc[a].x - sc[c].x) * (sc[b].y - sc[c].y)-
                 (sc[b].x - sc[c].x) * (sc[a].y - sc[c].y);

           if (nul>0)
             {
                t=vx[0];
                vx[0]=vx[2];
                vx[2]=t;
             }

           if (obj[n].st==FT_TEXTURE && texture[obj[n].t].addr!=NULL)
             {


                if (ZBUFF_F)
                  if (TEXTURE_NORMAL || TEXTURE_ENV)
                    draw_texture_triangle_zbuffer(vx,texture[obj[n].t].addr);
                  else
                    draw_texture_phong_light_triangle_zbuffer(v_arr,texture[obj[n].t].addr,
                                                              light_phong_map);
                else

                  {
                    if (TEXTURE_NORMAL || TEXTURE_ENV)
                      draw_texture_triangle(vx,texture[obj[n].t].addr);
//                      draw_texture_triangle_perspective(vx,texture[obj[n].t].addr);
                    else
                    if (TEXTURE_GOURAUD_LIGHT);
//                      draw_texture_gouraud_light_triangle(v_arr,texture[obj[n].t].addr);
                    else
                    if (TEXTURE_PHONG_LIGHT)
                      draw_texture_phong_light_triangle(vx,texture[obj[n].t].addr,
                                                           light_phong_map);
                  }
             } else

           if (obj[n].st==FT_GOURAUD)

             {
                if (ZBUFF_F)
                  draw_gouraud_triangle_zbuffer(vx,palette[obj[n].p].addr);
                else
                  draw_gouraud_triangle(vx,palette[obj[n].p].addr);

             } else

           if (obj[n].st==FT_FLAT)
             {
                z=ABS(n2f[num].z)*2.0;
                col=palette[obj[n].p].addr[(int)z];

                if (ZBUFF_F)
                  draw_flat_triangle_zbuffer(vx,col);
                else
                  draw_flat_triangle(vx,col);

             }


          if (SELECT_F && n==obj_n)
            {
                clip_line(scr,(int)sc[a].x,(int)sc[a].y,
                         (int)sc[b].x,(int)sc[b].y,WHITE);
                clip_line(scr,(int)sc[c].x,(int)sc[c].y,
                         (int)sc[a].x,(int)sc[a].y,WHITE);
                clip_line(scr,(int)sc[c].x,(int)sc[c].y,
                         (int)sc[b].x,(int)sc[b].y,WHITE);

            }

        }

      if (WIREFRAME_F)
      {
             clip_line(scr,sc[a].x,sc[a].y,sc[b].x,sc[b].y,WHITE);
             clip_line(scr,sc[c].x,sc[c].y,sc[b].x,sc[b].y,WHITE);
             clip_line(scr,sc[c].x,sc[c].y,sc[a].x,sc[a].y,WHITE);
             edges_c+=3;

             /*
             if (!l[l0].drawn)
             {
               line(scr,sc[a].x,sc[a].y,sc[b].x,sc[b].y,WHITE);
               l[l0].drawn=1;
               edges_c++;
             }

             if (!l[l1].drawn)
             {
               line(scr,sc[c].x,sc[c].y,sc[b].x,sc[b].y,WHITE);
               l[l1].drawn=1;
               edges_c++;
             }

             if (!l[l2].drawn)
             {
               line(scr,sc[c].x,sc[c].y,sc[a].x,sc[a].y,WHITE);
               l[l2].drawn=1;
               edges_c++;
             }
             */
      }

    }
}
/**/
uclock_t startuclock;
float frametime,framestart,frameend,framest;
float first,fps,frametimes=0;

void initftime(void) {
  startuclock=uclock();
}

double ftime(void) {

  return (double)(uclock()-startuclock)*1.0/UCLOCKS_PER_SEC;

}

/**/
void make_backfaces(void)
{
  int i,j,n;
  int a,b,c,t;


  for (n=0;n<maxobj;n++)
    {

       wr=obj[n].wr;
       n2f=obj[n].n2f;
       n2v=obj[n].n2v;

       for (i=0;i<obj[n].vertices;i++)
         {

           n2v[i].x=0;
           n2v[i].y=0;
           n2v[i].z=0;
         }
}
/*
       for (i=0;i<obj[n].faces;i++)
         {

           a=wr[i].a;
           b=wr[i].b;
           c=wr[i].c;

             {

                wr[i].a=c;
                wr[i].c=a;
             }
         }
    }*/
}
/**/
int main(int argc, char *argv[])
{

  __dpmi_regs regs;
  int t0,t1;
  int e,e1;
  int ch;
  gfx_mode mode320x200;
  gfx_mode mode640x480;

  int size;
  int quit=0;

  textmode(C4350);
  screen_bpp=15;

  maxpal=1;
  maxtex=0;

  palette[0].r=180;
  palette[0].g=0;
  palette[0].b=0;
  palette[0].l=70;
  make_palette(&palette[0]);

  startup(argc,argv);

  make_gouraud_light(50,150);
  make_phong_light(250);
//  make_background(255);

//  make_rgb_texture(texture[0].addr);



  open_lib();

  mode640x480.mode = find_vesa_mode(640, 480, 16, 1);
  if (mode640x480.mode == -1)
    {
      printf("No Vesa.\n");
      return 1;
    }
  else
  if (mode640x480.mode == -2)
    {
      printf("No Vesa 2.0.\n");
      return 1;

    }
  mode320x200.mode = find_vesa_mode(320, 200, 16, 1);

  printf("Found mode 640x480x16 : %x\n", 0x4000|mode640x480.mode);
  printf("Found mode 320x200x16 : %x\n", 0x4000|mode320x200.mode);

  printf("\nI'm ready.\n");
  getch();

  mode640x480.size_x = 640;
  mode640x480.size_y = 480;
  mode640x480.bpp = 16;
  mode320x200.size_x = 320;
  mode320x200.size_y = 200;
  mode320x200.bpp = 16;


  
  if (open_gfx(mode640x480)<0)
    {
      textmode(C80);
      printf("Error: Cannot open this mode.\n");
      return 1;
    };

  size=screen_w*screen_h;
  sx=screen_w/2;
  sy=screen_h/2;
  perspective=400.0;
  aspectratio=1.0;
  scr=(unsigned char *) malloc(640*480*2);
  zbuff=(int *) malloc(640*480*4);

  memset(scr,0,size*2);


  kb_install(0);

  text_bkg=-1;


  for (n=0;i<maxobj;i++) obj[n].hide=0;
  obj_n=0;

  initftime();

  framestart=ftime();
  first=framestart;
  framest=1.0;
  STOSL(scr,(int)((GREEN<<16)|GREEN),(size>>1));


  do {

            alphax=0.0;
            alphay=0.0;

            if (key[KB_UP])
              {
                     alphay=ALPHA;
                     REDRAW_F=1;
              }
            if (key[KB_DOWN])
              {
                     alphay=-ALPHA;
                     REDRAW_F=1;
              }
            if (key[KB_RIGHT])
              {
                     alphax=ALPHA;
                     REDRAW_F=1;
              }
            if (key[KB_LEFT])
              {
                     alphax=-ALPHA;
                     REDRAW_F=1;
              }
            if (key[KB_V])
              {
                     ob+=ob_step*framest;
                     REDRAW_F=1;
              }
            if (key[KB_SPACE])
              {
                     if (ob<0) ob-=ob_step*framest;
                     REDRAW_F=1;
              }

            switch (_kb_last_key)
              {

                 case KB_A:
                     ALL_FACES_F=!ALL_FACES_F;
                     REDRAW_F=1;
                     break;

                 case KB_S:
                     VBL_F=!VBL_F;

                     break;

                 case KB_W:
                     WIREFRAME_F=!WIREFRAME_F;
                     REDRAW_F=1;

 /*                    if (!EDGES_F)
                       {
                         text(screen,2,screen_h-10,WHITE,"Calculating edges...");
                         calc_line_points();
                         EDGES_F=1;
                       }           */
                     break;

                 case KB_C:
                     CHANGE_VIEW_F=!CHANGE_VIEW_F;
                     REDRAW_F=1;
                     break;

                 case KB_F1:
                     if (screen_w!=640)
                     {
                       free_vram();
                       open_gfx(mode640x480);
                       sx=320;
                       sy=240;
                       size=640*480;
                       perspective=400.0;
                       aspectratio=1.0;
                     }
                     REDRAW_F=1;
                     break;

                 case KB_F2:
                     if (screen_w!=320)
                     {
                       free_vram();
                       open_gfx(mode320x200);
                       sx=160;
                       sy=100;
                       size=320*200;
                       perspective=200.0;
                       aspectratio=0.72;
                     }
                     REDRAW_F=1;
                     break;

                 case KB_F5:
                     ZBUFF_F=!ZBUFF_F;
                     REDRAW_F=1;
                     break;

                 case KB_F12:
                     SELECT_F=!SELECT_F;
                     REDRAW_F=1;
                     break;


                 case KB_F:
                     FRAMESKIP_F=!FRAMESKIP_F;
                     break;

                 case KB_EQUAL:
                     if (FRAMESKIP_F)
                       if (frameskip<70.0) frameskip+=5.0;
                     key[KB_EQUAL]=0;
                     break;

                 case KB_MINUS:

                     if (FRAMESKIP_F)
                       if (frameskip>0.0) frameskip-=5.0;
                     key[KB_MINUS]=0;
                     break;

                 case KB_E:

                     i=0;
                     while (argv[1][i] != '.') i++;
                     argv[1][i+1]='3';
                     argv[1][i+2]='d';
                     argv[1][i+3]='g';
                     save_3dg(argv[1]);
                     textf(scr,2,screen_h-10,WHITE,"SAVED : %s",argv[1]);
                     break;

                 case KB_ESC:
                     if (SELECT_F)
                       {
                         SELECT_F=0;
                         REDRAW_F=1;
                       }
                     else
                       quit=1;
                     break;

              }

            _kb_last_key=0;

             if (key[KB_TAB])
               {
                     if (!key[KB_LSHIFT])
                       {
                         obj_n++; if (obj_n>maxobj-1) obj_n=0;
                       }
                     else
                       {
                         obj_n--; if (obj_n<0) obj_n=maxobj-1;
                       }
                     REDRAW_F=1;
                     key[KB_TAB]=0;
               }

            if (alphax!=0.0 || alphay!=0.0)
               frot3(framest*alphax,framest*alphay);
 
 
            if (REDRAW_F)
              {
                if (ZBUFF_F)
                 STOSL(zbuff,-2000000000,size);
//                 STOSL(zbuff,-2,size);
                 STOSL(scr,(int)((GREEN<<16)|GREEN),(size>>1));
 //                clean(scr,(int)((GREEN<<16)|GREEN));

                calcp2();
                draw_objects();
//                memcpy(scr,bbkg,size<<1);
                if (SELECT_F) REDRAW_F=0;
              }
            frameend=ftime();
            frametime=frameend-framestart;
            framestart=frameend;
            if (FRAMESKIP_F)
              framest=frametime*frameskip;
            else
              framest=1.0;
        

            fps=1.0/frametime;

            frametimes+=frametime;

            for (i=00;i<11;i++) STOS(i*screen_w,WHITE,150);
            for (i=11;i<22;i++)
              {
                STOS(i*screen_w,COL15(0,0,100),150);
                STOSW1(i*screen_w,WHITE);
                STOSW1(i*screen_w+149,WHITE);
              }

            STOS(22*screen_w,WHITE,150);
 
            textf(scr,2,13,COL15(0,255,0),"FPS %f",(float)fps);
            text(scr,1,2,0,"3D FROM DGS CO'96");
 
            if (WIREFRAME_F)
              textf(scr,screen_w-15*8-2,screen_h-9,LGREEN,"Edges : %d",edges_c);
 

 
            if (SELECT_F)
              {
                display_local_menu();
              }
 
            if (VBL_F)
              {
                text(scr,2,screen_h-10,LGREEN,"VBL");
                vbl();
              }
            if (ZBUFF_F)
              {
                text(scr,2,screen_h-20,LGREEN,"ZBUFF");
              }
            if (FRAMESKIP_F)
              {
                textf(scr,2,screen_h-30,LGREEN,"FRAMESKIP AT %d FPS",(int)frameskip);
              }

            copy(scr,screen,(size>>1));
//             move(screen,scr);




  } while ( !quit);


  kb_remove();


  close_gfx();
  close_lib();

  clrscr();
  free(scr);
  free(dr);
  free(zbuff);

  for (i=0;i<maxobj;i++)
    {

      dfree(obj[i].v);
      dfree(obj[i].n2v);
      dfree(obj[i].n2f);
      dfree(obj[i].wr);
      dfree(obj[i].sc);
      dfree(obj[i].uv);
      dfree(obj[i].l);

    }
  for (i=0;i<maxpal;i++)
    free(palette[i].addr);
  for (i=0;i<maxtex;i++)
    free(texture[i].addr);
  free(light_phong_map);

  free(texture_rgb);
  free(bkg);
  free(bbkg);
 // free(background);
  textmode(C80);
  return 0;
}
