#include <conio.h>
#include <stdio.h>
#include <math.h>

#include "3dtypes.h"
#include "gfx.h"

extern int maxobj;
extern int sx;
extern int sy;
int avertices,afaces,aedges;
extern float ob,ob_step,perspective,aspectratio;
extern object obj[];

float lminx,lminy,lminz;
float lmaxx,lmaxy,lmaxz;

extern float lx,ly,lz;



/**/
void sort(int n)
{
  int i,j,k;
  float a;
  int s;
  int l,p;
  drs dr1;
  struct
    {
      int l,p;
    } stos[150];


  s=1;
  stos[1].l=0;
  stos[1].p=n;

  do {
       l=stos[s].l;
       p=stos[s].p;
       s--;
       do {
            i=l; j=p; a=dr[(l+p) >> 1].z;
            do {
                 while (dr[i].z<a) i++;
                 while (a<dr[j].z) j--;
                 if (i<=j)
                   {

                     dr1=dr[i];
                     dr[i]=dr[j];
                     dr[j]=dr1;

                     i++; j--;

                   }
            } while (i<=j);
            if (i<p)
              {
                s++;
                stos[s].l=i;
                stos[s].p=p;
              }
            p=j;
       } while (l<p);
   } while (s!=0);
}
/**/
void calc_normals(void)
{

  typedef struct VP
    {
       int p[30];
       int m;
    } VP;


  float x1,x2;
  float y1,y2;
  float z1,z2;
  float l;
  float nx,ny,nz;
  float ll;
  int i,j,n;
  int a,b,c;
  int max;
  int *f;
  VP *vp;
  int m;


  float ns,nt;

  nt=0.0;
  ns=(avertices)/10.0;
  gotoxy(25,wherey()-1);

  for (n=0;n<maxobj;n++)
  {
    printf("[Obj :%d]\n",n);
    gotoxy(25,wherey()-1);

    v=obj[n].v;
    n2v=obj[n].n2v;
    n2f=obj[n].n2f;
    wr=obj[n].wr;
    uv=obj[n].uv;

    vp=(VP *) malloc(obj[n].vertices*sizeof(VP));
    memset(vp,0,sizeof(VP)*obj[n].vertices);

    for (i=0;i<obj[n].faces;i++)
      {
         a=wr[i].a;
         b=wr[i].b;
         c=wr[i].c;

         x1=v[b].x-v[a].x;
         x2=v[c].x-v[a].x;
         y1=v[b].y-v[a].y;
         y2=v[c].y-v[a].y;
         z1=v[b].z-v[a].z;
         z2=v[c].z-v[a].z;

         n2f[i].x=-(y1*z2-y2*z1);
         n2f[i].y= (x1*z2-x2*z1);
         n2f[i].z= (y1*x2-y2*x1);

         m=vp[a].m;
         vp[a].p[m]=i;

         m=vp[b].m;
         vp[b].p[m]=i;

         m=vp[c].m;
         vp[c].p[m]=i;

         vp[a].m++;
         vp[b].m++;
         vp[c].m++;
  
      }
  
    for (i=0;i<obj[n].vertices;i++)
      {

         nx=0;ny=0;nz=0;

         for (j=0;j<vp[i].m;j++)
           {

             m=vp[i].p[j];
             nx+=n2f[m].x;
             ny+=n2f[m].y;
             nz+=n2f[m].z;

           }
  
         l=sqrt(nx*nx+ny*ny+nz*nz);
         if (l>0)
           {
              ll=127.0/l;
              nx*=ll;
              ny*=ll;
              nz*=ll;

           }

         n2v[i].x=nx;     uv[i].x=nx;
         n2v[i].y=ny;     uv[i].y=ny;
         n2v[i].z=nz;     uv[i].z=nz;

         nt+=1.0;

//         if (nt>=ns-1.0) {putch('*');nt=0.0;}
      }
    free(vp);

    for (i=0;i<obj[n].faces;i++)
      {
         nx=n2f[i].x;
         ny=n2f[i].y;
         nz=n2f[i].z;

         l=sqrt(nx*nx+ny*ny+nz*nz);
         if (l>0)
           {
              ll=(127.0/l);

              nx*=ll;
              ny*=ll;
              nz*=ll;

           }
         n2f[i].x=nx;
         n2f[i].y=ny;
         n2f[i].z=nz;
      }



  }

}
/**/
void calc_line_points()
{
  int i,j,n,s,e,p,r,se;
  int a,b,c;
  int volatile k;

  l2d *l;
  l2d *lt;

  aedges=0;

  gotoxy(25,wherey()-1);

  for (n=0;n<maxobj;n++)
    {
       //printf("[Obj :%d]\n",n);

//       textf(screen,2+21*8,screen_h-10,12499,"[Obj :%d]",n-1);
       text_bkg=12499;
       textf(screen,2+21*8,screen_h-10,0xFFFF,"[Obj :%d]",n);
       text_bkg=-1;
//       gotoxy(25,wherey()-1);

       obj[n].l=(l2d *) calloc(obj[n].faces*3,sizeof(l2d));
       if (obj[n].l==NULL) printf("Mem error\n");


       v=obj[n].v;
       l=obj[n].l;
       wr=obj[n].wr;

       k=0;
       for (i=0;i<obj[n].faces;i++)
         {

           a=wr[i].a;
           b=wr[i].b;
           c=wr[i].c;

           l[k].n=i;
           if (a<b)
             {

               l[k].s=a;
               l[k].e=b;
             }
           else
             {
               l[k].s=b;
               l[k].e=a;
             }
           k++;
           l[k].n=i;
           if (b<c)
             {

               l[k].s=b;
               l[k].e=c;
             }
           else
             {
               l[k].s=c;
               l[k].e=b;
             }
           k++;
           l[k].n=i;
           if (c<a)
             {

               l[k].s=c;
               l[k].e=a;
             }
           else
             {
               l[k].s=a;
               l[k].e=c;
             }
           k++;

         }

       r=k;

       for (i=0;i<k;i++)
         {

           s=l[i].s;
           e=l[i].e;


           p=0;
           for (j=i+1;j<k;j++)
             {
//                  if ((l[j].s==s && l[j].e==e) ||
  //                    (l[j].e==s && l[j].s==e))

                  if (l[j].s==s && l[j].e==e)

                  {
                     memcpy(&l[j],&l[j+1],(k-j)*sizeof(l2d));
                     k--;

                  }
             }
         }

       obj[n].edges=k;
       aedges+=k;
    }
  text_bkg=12499;
  textf(screen,2,screen_h-10,0xFFFF,"Profiling faces table......",n);
  text_bkg=-1;

  for (n=0;n<maxobj;n++)
    {
       l=obj[n].l;
       wr=obj[n].wr;


       for (i=0;i<obj[n].faces;i++)
         {

           a=wr[i].a;
           b=wr[i].b;
           c=wr[i].c;

           for (j=0;j<obj[n].edges;j++)
             {

                s=l[j].s;
                e=l[j].e;

                if ( (s==a && e==b) ||
                     (s==b && e==a) )

                  wr[i].l0=j;

                if ( (s==b && e==c) ||
                     (s==c && e==b) )

                  wr[i].l1=j;

                if ( (s==a && e==c) ||
                     (s==c && e==a) )

                  wr[i].l2=j;

             }
         }

    }

}
/**/
void find_lxyz()
{
  int n,i;
  float minx,miny,minz;
  float maxx,maxy,maxz;

  v=obj[0].v;
  lmaxx=v[0].x;lminx=v[0].x;
  lmaxy=v[0].y;lminy=v[0].y;
  lmaxz=v[0].z;lminz=v[0].z;

  for (n=0;n<maxobj;n++)
  {

    v=obj[n].v;
    maxx=v[0].x;minx=v[0].x;
    maxy=v[0].y;miny=v[0].y;
    maxz=v[0].z;minz=v[0].z;

    for (i=0;i<obj[n].vertices;i++)
      {
        if (v[i].x>maxx) maxx=v[i].x;
        if (v[i].y>maxy) maxy=v[i].y;
        if (v[i].z>maxz) maxz=v[i].z;
        if (v[i].x<minx) minx=v[i].x;
        if (v[i].y<miny) miny=v[i].y;
        if (v[i].z<minz) minz=v[i].z;
      }

    if (lmaxx<maxx) lmaxx=maxx;
    if (lmaxy<maxy) lmaxy=maxy;
    if (lmaxz<maxz) lmaxz=maxz;
    if (lminx>minx) lminx=minx;
    if (lminy>miny) lminy=miny;
    if (lminz>minz) lminz=minz;

    obj[n].x=(minx+maxx)/2.0;
    obj[n].y=(miny+maxy)/2.0;
    obj[n].z=(minz+maxz)/2.0;

  }
  lx=(lminx+lmaxx)/2.0;
  ly=(lminy+lmaxy)/2.0;
  lz=(lminz+lmaxz)/2.0;
}
/**/
void calc_ob(void)
{

  find_lxyz();

  ob= -((lmaxz-lminz)+(lmaxx-lminx)+(lmaxy-lminy))/2.0  ;

  ob_step=ob/80.0;

}
/**/
void center_object(void)
{
  float mx,my,mz,l;
  int n,i;

  for (n=0;n<maxobj;n++)
    for (i=0;i<obj[n].vertices;i++)

       {

         obj[n].v[i].x-=lx;
         obj[n].v[i].y-=ly;
         obj[n].v[i].z-=lz;

       }

}
/**/
void calcp2(void)
{
  int n,i;
  float rob,t;

  for (n=0;n<maxobj;n++)
    {

       v=obj[n].v;
       sc=obj[n].sc;

       for (i=0;i<obj[n].vertices;i++)

         {
           t=v[i].z+ob;

           if (t!=0) {

             rob=perspective/t;
             sc[i].x= (v[i].x*rob+sx);
             sc[i].y= (v[i].y*rob*aspectratio+sy);
           } else
           {
             sc[i].x=0;
             sc[i].y=0;
           }


         }

    }
}
/**/
void frot3(float alfax,float alfay)
{
  int i,n;
  float r1,r2,yz,zx;
  float x,y,z;

  float dnx,dny;
  float c1,s1,sc1,c2,s2,sc2;

  float dx,dy,dz;

  c1=cos(alfay);
  s1=sin(alfay);
  sc1=c1*s1;

  c2=cos(alfax);
  s2=sin(alfax);
  sc2=c2*s2;


  for (n=0;n<maxobj;n++)
  {


      v=obj[n].v;
      n2v=obj[n].n2v;
      n2f=obj[n].n2f;

      for (i=0;i<obj[n].vertices;i++)
       {
/*                y = v[i].y;
                z = v[i].z;
    
                r1 = ly+(y-ly)*c1+(z-lz)*s1;
                r2 = lz+(z-lz)*c1-(y-ly)*s1;


                v[i].y=r1;
                v[i].z=r2;

                x = v[i].x;
                z = v[i].z;
    
                r1 = lx+(x-lx)*c2-(z-lz)*s2;
                r2 = lz+(z-lz)*c2+(x-lx)*s2;

                
                v[i].x=r1;
                v[i].z=r2;*/

                y = v[i].y;
                z = v[i].z;
    
                r1 = y*c1+z*s1;
                r2 = z*c1-y*s1;


                v[i].y=r1;
                v[i].z=r2;

                x = v[i].x;
                z = v[i].z;
    
                r1 = x*c2-z*s2;
                r2 = z*c2+x*s2;

                v[i].x=r1;
                v[i].z=r2;


                y = n2v[i].y;
                z = n2v[i].z;
    
                r1 = y*c1+z*s1;
                r2 = z*c1-y*s1;
    

                n2v[i].y=r1;
                n2v[i].z=r2;

                x = n2v[i].x;
                z = n2v[i].z;
    
                r1 = x*c2-z*s2;
                r2 = z*c2+x*s2;

    
                n2v[i].x=r1;
                n2v[i].z=r2;

    
       }
      for (i=0;i<obj[n].faces;i++)
       {

                y = n2f[i].y;
                z = n2f[i].z;
    
                r1 = y*c1+z*s1;
                r2 = z*c1-y*s1;
    

                n2f[i].y=r1;
                n2f[i].z=r2;

                x = n2f[i].x;
                z = n2f[i].z;
    
                r1 = x*c2-z*s2;
                r2 = z*c2+x*s2;

    
                n2f[i].x=r1;
                n2f[i].z=r2;

    
       }
         /*
      for (i=0;i<obj[n].vertices;i++)
       {
                x = v[i].x;
                z = v[i].z;
    
                zx=z*x;
    
    
                r1 = (z+c1) * (x+s1) - zx - sc1;
                r2 = (z-s1) * (x+c1) - zx + sc1;
    
                v[i].x=r1;
    

                y = v[i].y;
                z = r2;
    
                yz=y*z;
    
    
                r1 = (y-s2) * (z+c2) - yz + sc2;
                r2 = (y+c2) * (z+s2) - yz + sc2;
    
                v[i].y=r1;
                v[i].z=r2;


                x = n2v[i].x;
                z = n2v[i].z;
    
                zx=z*x;
    
    
                r1 = (z+c1) * (x+s1) - zx - sc1;
                r2 = (z-s1) * (x+c1) - zx + sc1;
    
                n2v[i].x=r1;


                y = n2v[i].y;
                z = r2;
    
                yz=y*z;
    
                r1 = (y-s2) * (z+c2) - yz + sc2;
                r2 = (y+c2) * (z+s2) - yz + sc2;
    
    
                n2v[i].y=r1;
                n2v[i].z=r2;
    
       }   */
  }
}
/**/
void scale_object(float s)
{
  int i,n;

  for (n=0;n<maxobj;n++)

     for (i=0;i<obj[n].vertices;i++)
       {
         obj[n].v[i].x*=s;
         obj[n].v[i].y*=s;
         obj[n].v[i].z*=s;
       }


}
/**/

