typedef struct vector3d
   {
     float x;
     float y;
     float z;
     float null;

   } v3d;

typedef struct point2d
   {
     float x;
     float y;
   } p2d;

typedef struct face3d
   {
     int a;
     int b;
     int c;
     int l0;
     int l1;
     int l2;
     int back;
     int null;

   } f3d;

typedef struct line2d
   {
     int s; //start point
     int e; //end point
     int n; //face number
     int drawn;

   } l2d;

typedef struct dr_s
  {
    int z;
    int num;
    int n;
//    int null;

  } drs;

typedef struct t2d
  {
    long x,y;
    long u,v;
    long ul,vl;
    long l;
    long z;
    int visible;
  } t2d;

typedef struct t2df
  {
    float x,y;
    float u,v;
    float ul,vl;
    float l;
    float z;
    int visible;
  } t2df;


drs *dr;
drs *drp;
p2d *sc;
f3d *wr;
v3d *v;
v3d *n2v;
v3d *n2f;
v3d *uv;

typedef struct object
  {
      v3d *v;
      v3d *n2v;
      v3d *n2f;
      f3d *wr;
      p2d *sc;

      v3d *uv;

      l2d *l;

      int faces;
      int vertices;
      int edges;
      int hide;

      int  st;
      int  p;   //palette//
      int  t;   //texture//

      /*
          shading_type:

          0-gouraud
          1-gouraud persp
          2-texture
          3-texture persp
          4-texture env
          5-texture env persp
          6-texture gouraud light
          7-texture persp gouraud light
          8-texture phong light
          9-texture persp phong light
      */

      float x,y,z;  // local axis
      float s;      // local scale


   }  object;



struct tex
  {

    char *addr;
    char filename[8+3+1];

  } texture[10];

struct pal

  {
    short *addr;
    int r,g,b,l;

  } palette[10];

struct phong

  {
    char *addr;
    int r,g,b,l;

  } phong[10];

