#include "3dtypes.h"

#define VISIBLE 0
#define LEFT    1
#define RIGHT   2
#define TOP     4
#define BOTTOM  8

#define XMIN 0.0
#define XMAX 320.0
#define YMIN 0.0
#define YMAX 200.0

extern int screen_w,screen_h;

/**/
int cliptest(t2df *v)
{
  int vis;

  vis=VISIBLE;

  if (v->x<0.0)      vis|=LEFT;
  if (v->x>screen_w) vis|=RIGHT;
  if (v->y<0.0)      vis|=TOP;
  if (v->y>screen_h) vis|=BOTTOM;

  return vis;

}
/**/
__inline__ int cliptestx(t2df *v)
{
  int vis;

  vis=VISIBLE;

  if (v->x<0.0)      vis|=LEFT;
  if (v->x>screen_w) vis|=RIGHT;

  return vis;
}
/**/
__inline__ int cliptesty(t2df *v)
{
  int vis;

  vis=VISIBLE;

  if (v->y<0.0)      vis|=TOP;
  if (v->y>screen_h) vis|=BOTTOM;

  return vis;
}
/**/
float p[4]={0.0,0.0,0.0,0.0};      /* l,r,t,b */


int clip(t2df ***out0,t2df *in0)
{
  int i,j,n,k;
  t2df *v,*v0,*v1,*v2;

  static t2df *inl[12],
              *outl[12];

  t2df **in=inl,
       **out=outl,
       **tmp;

  float a,ima,cl;


  int clipbit;


  inl[0]=in0+0;
  inl[1]=in0+1;
  inl[2]=in0+2;
  inl[3]=in0+0;


  p[1]=screen_w;
  p[3]=screen_h;

  in0+=3;
  n=3;
  j=0;
  clipbit=1; /* left */


  for (k=0;k<4;k++)
    {

        cl=p[k];

        for(i=0; i<n; i++) {
            v1 = in[i];
            v2 = in[i+1];
            if((v1->visible & clipbit) == VISIBLE) {
                out[j++] = v1;
                if((v2->visible & clipbit) == VISIBLE)
                    continue;
            } else
                if((v2->visible & clipbit) != VISIBLE)
                    continue;

            out[j] = in0++;

            if (k<2)
              {
                a = (cl - v1->x) / (v2->x - v1->x);
                ima = 1.0-a;
                out[j]->y = v1->y*ima + v2->y*a;
                out[j]->x = cl;
                out[j]->visible = cliptesty(out[j]);
              }
            else
              {
                a = (cl - v1->y) / (v2->y - v1->y);
                ima = 1.0-a;
                out[j]->x = v1->x*ima + v2->x*a;
                out[j]->y = cl;
                if (k<3) out[j]->visible = cliptestx(out[j]);
              }

            out[j]->u  = v1->u*ima + v2->u*a;
            out[j]->v  = v1->v*ima + v2->v*a;
            out[j]->ul = v1->ul*ima + v2->ul*a;
            out[j]->vl = v1->vl*ima + v2->vl*a;
            out[j]->l  = v1->l*ima + v2->l*a;
            out[j]->z  = v1->z*ima + v2->z*a;
            j++;
        }
        if (k<3)
          {
            out[j] = out[0];
            tmp = in; in = out; out = tmp;
            n = j;
            j = 0;
          }

        clipbit<<=1;
    }

  *out0=out;


  return j;

}
/**/

