#include "3dtypes.h"

/*
   Correct perspective mapper
   Floating point version
*/

/**/

extern int screen_w;
extern int screen_h;
extern char *scr;
extern char *texture;


t2d_f  *right_f[3];
t2d_f  *left_f[3];

int  left_s,right_s;

float left_x_f,right_x_f;
float left_dx_f,right_dx_f;

float left_u_f,left_v_f;
float left_du_f,left_dv_f;

/**/
int calc_right_deltas_f(t2d_f *v1, t2d_f *v2)
{
  float dy;

  dy=v2->y - v1->y;

  if (right_s==0) return -1;
  if (dy==0.0) return -1;

  right_dx_f = ( v2->x - v1->x ) / dy;
  right_x_f=v1->x;

  return 0;

}

int calc_left_deltas_f(t2d_f *v1, t2d_f *v2)
{

  float dy;

  dy=v2->y - v1->y;

  if (left_s==0) return -1;
  if (dy==0.0) return -1;

  left_dx_f  = ( v2->x - v1->x ) / dy;
  left_du_f  = ( v2->u - v1->u ) / dy;
  left_dv_f  = ( v2->v - v1->v ) / dy;


  left_x_f=v1->x;
  left_u_f=v1->u;
  left_v_f=v1->v;

  return 0;

}
/**/
int phong_cp(t2d_f *va)
{

  t2d_f *v1=va;
  t2d_f *v2=va+1;
  t2d_f *v3=va+2;

  int dx,dy;
  float xc1,xc2;
  int y,y3;
  int ad,ad1;
  float w,h;
  double u,v,du,dv;
  double d,id;

  float min_x,max_x;

  char *screen;
  t2d_f  *t;

  float dy1,dy2;

  if (v1->y > v3->y) { t=v1;v1=v3;v3=t; }
  if (v2->y > v3->y) { t=v2;v2=v3;v3=t; }
  if (v1->y > v2->y) { t=v1;v1=v2;v2=t; }


  w=screen_w-1;
  h=screen_h-1;

  if (v3->y<0.0)         return;
  if (v1->y>h)           return;
  if (v3->y-v1->y==0.0)  return;
  if (v3->y>h)           y3=h; else y3=v3->y;

  min_x=v1->x;
  if (v2->x<min_x) min_x=v2->x;
  if (v3->x<min_x) min_x=v3->x;

  max_x=v1->x;
  if (v2->x>max_x) max_x=v2->x;
  if (v3->x>max_x) max_x=v3->x;

  if (max_x<0.0) return;
  if (min_x>w) return;


  dy1=v2->y - v3->y;
  dy2=v1->y - v3->y;

  d = (v1->x - v3->x) * dy1 -
      (v2->x - v3->x) * dy2;

  if(d == 0.0) return;

  id = 1.0/d; //* 65536.0;

  du = ((v1->u - v3->u) * dy1 -
        (v2->u - v3->u) * dy2) * id;
  dv = ((v1->v - v3->v) * dy1 -
        (v2->v - v3->v) * dy2) * id;

  if (d>0.0)
    {
      right_s=2;
      right_f[0]=v1;
      right_f[1]=v2;
      right_f[2]=v3;

      left_s=1;

      left_f[0]=v1;
      left_f[1]=v3;

    }
  else
    {
      left_s=2;
      left_f[0]=v1;
      left_f[1]=v2;
      left_f[2]=v3;

      right_s=1;

      right_f[0]=v1;
      right_f[1]=v3;


    }


  calc_right_deltas_f(right_f[0],right_f[1]);
  calc_left_deltas_f(left_f[0],left_f[1]);



  ad=(int)v1->y*screen_w;
  y=v1->y;

  do
    {


      if (y==(int)v2->y)
        {


            if (right_s==2)
              if (calc_right_deltas_f(right_f[1],right_f[2])<0) return;

            if (left_s==2)
              if (calc_left_deltas_f(left_f[1],left_f[2])<0) return;
        }



      if (y>=0) {


        xc1=left_x_f;
        xc2=right_x_f;

        u=left_u_f;
        v=left_v_f;


        if (xc1<0)
          {

            u+=du*(-xc1);
            v+=dv*(-xc1);
            xc1=0;
          }


        if (xc2>w) xc2=w;

        dx=xc2-xc1;

        ad1=ad+xc1;

        if (dx>0)
          {

            while (dx--)

              {

                scr[ad1++]=texture[ ( (int) (v)*256) + (int) u ];

                u+=du;
                v+=dv;


              }

          }

        }

        left_x_f+=left_dx_f;
        left_u_f+=left_du_f;
        left_v_f+=left_dv_f;

        right_x_f+=right_dx_f;

        ad+=screen_w;



    } while (y++<y3);


}
/**/
