#include "3dtypes.h"
#include "poly.h"
#include <strings.h>

/**/

extern int screen_w;
extern int screen_h;
extern char *scr;
extern long  *zbuff;

static short *screen;


static long z,dz;
static long left_x,left_z,right_x;
static long left_dx,left_dz,right_dx;


static long left_h;
static long right_h;
static long height;
static long width;
static long inv_height;
static long prestep;


static t2d *min_v,*max_v,*end_v,*start_v;
static t2d *right_v,*left_v;
static long maxy,miny;


/**/
static void calc_right_deltas()
{
  t2d *v1,*v2;

  v1=right_v;

  if (right_v>start_v)
    v2=right_v-1;
  else
    v2=end_v;

  right_v=v2;

  right_h=ceil(v2->y) - ceil(v1->y);

  if (right_h<=0) return;

  prestep = (ceil(v1->y) << 16) - v1->y;

  if (right_h>1)
    {
      height=v2->y - v1->y;
      right_dx = idiv16( v2->x - v1->x , height);
    }
  else
    {
      inv_height = (0x10000 << 14) / (v2->y - v1->y);
      right_dx = imul14(v2->x - v1->x, inv_height);

    }

  right_x  = v1->x + imul16(prestep,right_dx);

  return;

}
/**/
static void calc_left_deltas()
{

  t2d *v1,*v2;

  v1=left_v;

  if (left_v<end_v)
    v2=left_v+1;
  else
    v2=start_v;

  left_v=v2;


  left_h=ceil(v2->y) - ceil(v1->y);

  if (left_h<=0) return;

  prestep = (ceil(v1->y) << 16) - v1->y;

  if (left_h>1)
    {

      height=v2->y - v1->y;
      left_dx  = idiv16( v2->x - v1->x , height);
      left_dz  = idiv16( v2->z - v1->z , height);
    }
  else
    {
      inv_height = (0x10000 << 14) / (v2->y - v1->y);
      left_dx = imul14(v2->x - v1->x, inv_height);
      left_dz = imul14(v2->z - v1->z, inv_height);
    }
    
  left_x=v1->x  + imul16(prestep,left_dx);
  left_z=v1->z  + imul16(prestep,left_dz);

  return;

}
/**/
void draw_flat_poly_zbuffer(t2d *va,int vertices,int col)
{

  t2d *v0;

  long x1;

  int i;
  int ad,ad1;




  start_v = va;
  min_v   = va;
  max_v   = va;


  miny=va->y;
  maxy=va->y;

  v0      = va+1;

  for (i=1;i<vertices;i++)
    {

      if (v0->y<miny)
        {
          miny=v0->y;
          min_v=v0;
        } else
      if (v0->y>maxy)
        {
  
          maxy=v0->y;
          max_v=v0;
        }
      v0++;
    }

  end_v   = v0-1;
  left_v  = min_v;
  right_v = min_v;




  do {

      if (right_v == max_v)
        return;
      calc_right_deltas();
  } while (right_h<=0);

  do {

      if (left_v == max_v)
        return;
      calc_left_deltas();
  } while (left_h<=0);




  ad=ceil(min_v->y)*screen_w;


  for (;;)
    {

        x1 = ceil(left_x);
        width = ceil(right_x) - x1;


        if (width>0)
          {
            prestep = (x1 << 16) - left_x;
            z = left_z + imul16(prestep, dz);

            ad1=ad+x1;
            while (width--)
              {
                if (z>=zbuff[ad1])
                  {

                    *((short *)scr+ad1)=col;
                    zbuff[ad1]=z;
                  }

                ad1++;
                z+=dz;

              }

/*            asm (

            "

            n_x:

                 cmpl (%%esi),%%ebx
                 jl not_in_zbuffer

                 movw %%ax,(%%edi)
                 movl %%ebx,(%%esi)


            not_in_zbuffer:

                 addl $2,%%edi
                 addl $4,%%esi
                 addl %%edx,%%ebx
                 decl %%ecx

                 jg n_x

            end:

                 "
             :
             : "D" (scr+(ad+x1)*2),"S" (zbuff+((ad+x1)<<2)),
               "c" (width),"a" (col),"b" (z), "d" (dz)
             : "%edi","%esi","%ebx","%ecx","%eax","%edx"


            );*/
         }


        if (--right_h<=0)
        do {
      
            if (right_v == max_v)
              return;
            calc_right_deltas();
      
        } while (right_h<=0);

          else

        right_x+=right_dx;


        if (--left_h<=0)
        do {
      
            if (left_v == max_v)
              return;
            calc_left_deltas();
        } while (left_h<=0);

          else
        {
          left_x+=left_dx;
          left_z+=left_dz;
        }


        ad+=screen_w;



    }


}
/**/
void draw_flat_triangle_zbuffer(t2df *va,int col)
{
  t2df *v1=va;
  t2df *v2=va+1;
  t2df *v3=va+2;

  static t2d  vx[12];
  static t2df **dst,*t;


  double dy1,dy2;
  double d,id;
  int    i,max;

  double  ddz;



  v1->visible=cliptest(v1);
  v2->visible=cliptest(v2);
  v3->visible=cliptest(v3);

  if ( (v1->visible & v2->visible & v3->visible) != VISIBLE )
    return;



  dy1=v2->y - v3->y;
  dy2=v1->y - v3->y;

  d = (v1->x - v3->x) * dy1 -
      (v2->x - v3->x) * dy2;

  if (d == 0.0) return;

  id = 1.0/d*65536.0;

  ddz = ( (v1->z - v3->z) * dy1 - (v2->z - v3->z) * dy2 ) *id ;

  max=3;

  if ( ( (v1->visible | v2->visible | v3->visible) & 0xff )== VISIBLE )
    {
      fistpLZ(&vx[0].x,&v1->x);
      fistpLZ(&vx[1].x,&v2->x);
      fistpLZ(&vx[2].x,&v3->x);
    }
  else
    {
      max=clip(&dst,va);
      if (max<3) return;

      for (i=0;i<max;i++)
        fistpLZ(&vx[i].x,&dst[i]->x);
    }


  fistp(&dz,&ddz);

  draw_flat_poly_zbuffer(vx,max,col);


}
/**/
