char *screen;
int  screen_bpp;
int  screen_w;
int  screen_h;
int  text_bkg;

typedef struct gfx_mode
{
  int size_x;
  int size_y;
  int bpp;
  int mode;
} gfx_mode;

typedef struct pal8
 {
   unsigned char r;
   unsigned char g;
   unsigned char b;
 } pal8;

#define COL16(r,g,b) \
  (((r >> 3) << 11) | ((g >> 2) << 5) | ((b >> 3) << 0))

#define COL15(r,g,b) \
  (((r >> 3) << 11) | ((g >> 2) << 5) | ((b >> 3) << 0))
//  (((r >> 3) << 10) | ((g >> 3) << 5) | ((b >> 3) << 0))

#define COL32(r,g,b) \
  ( (r<<24) | (g<<16) | (b<<8) )

#define GETR16(r) \
  (((r) >> 11) << 3)

#define GETG16(g) \
  (((g) >> 5) << 2)

#define GETB16(b) \
  (((b) >> 0) << 3)
  
#define GETR15(r) \
  (((r) >> 10) << 3)

#define GETG15(g) \
  ((((g)&0x3e0) >> 5) << 3)

#define GETB15(b) \
  ((((b)&0x1f) >> 0) << 3)

#define FONT_STANDART 0
#define FONT_COMPUTER 1

/**/
extern void close_gfx(void);
/**/
extern int open_lib();
/**/
extern int close_lib();
/**/
void (*text)(char *img,int x,int y,int col,const char *t);
/**/
extern void textf(char *img,int x,int y,int col,const char *t,...);
/**/
extern void vbl();
/**/
extern int  (*line)(char *img,int x1,int y1,int x2,int y2,int c);
/**/
extern void clip_line(char *img,float x1,float y1,float x2, float y2,int col);
/**/
extern int  open_gfx(gfx_mode gmode);
/**/
extern int find_vesa_mode(int w, int h, int color_depth, int vbe2);
/**/
extern void close_gfx(void);
/**/
extern void free_vram(void);
/**/
extern void set_color(int n,int r,int g,int b);
/**/
extern void set_palette(char *pal);
/**/
extern char *load_bmp(pal8 *pal,char *filename);
/**/
extern char *load_tga(char *filename);
/**/
extern void show_bmp(char *img,char *bmp,int w,int h);
/**/
extern void set_font(int num);
/**/

