#include "3dtypes.h"
// Gouraud shading //
/**/

extern int screen_w;
extern int screen_h;
extern char *scr;

static int l;
static long dl;

static t2d  *right[3];
static t2d  *left[3];

static int  left_s,right_s;
static int  x;

static int left_x,right_x;
static int left_dx,right_dx;

static int left_l;
static int left_dl;

/**/
static int calc_right_deltas(t2d *v1, t2d *v2)
{
  int dy;

  dy=v2->y - v1->y;

  if (dy==0) return -1;

  right_dx = ( ( v2->x - v1->x ) << 16 ) / dy;
  right_x=v1->x<<16;

  return 0;

}

static int calc_left_deltas(t2d *v1, t2d *v2)
{

  int dy;

  dy=v2->y - v1->y;

  if (dy==0) return -1;

  left_dx  = ( ( v2->x - v1->x ) << 16 ) / dy;

  left_x=v1->x<<16;

  return 0;

}
/**/
int draw_line_triangle(t2d *va)
{

  t2d *v1=va;
  t2d *v2=va+1;
  t2d *v3=va+2;

  int dx,dy;
  int xc1,xc2;
  int t,y,y3;
  int ad,ad1;
  int w,h;
  double d,id;

  int min_x,max_x;

  t2d  *v;

  int dy1,dy2,i;

  if (v1->y > v3->y) { v=v1;v1=v3;v3=v; }
  if (v2->y > v3->y) { v=v2;v2=v3;v3=v; }
  if (v1->y > v2->y) { v=v1;v1=v2;v2=v; }


  w=screen_w-1;
  h=screen_h-1;

  if (v3->y<0)        return;
  if (v1->y>h)        return;
  if (v3->y-v1->y==0) return;
  if (v3->y>h)        y3=h;else y3=v3->y;

  min_x=v1->x;
  if (v2->x<min_x) min_x=v2->x;
  if (v3->x<min_x) min_x=v3->x;

  max_x=v1->x;
  if (v2->x>max_x) max_x=v2->x;
  if (v3->x>max_x) max_x=v3->x;

  if (max_x<0) return;
  if (min_x>w) return;


  dy1=v2->y - v3->y;
  dy2=v1->y - v3->y;

  d = (v1->x - v3->x) * dy1 -
      (v2->x - v3->x) * dy2;

  if(d == 0.0) return;


  if (d>0)
    {
      right_s=2;
      right[0]=v1;
      right[1]=v2;
      right[2]=v3;

      left_s=1;

      left[0]=v1;
      left[1]=v3;

    }
  else
    {
      left_s=2;
      left[0]=v1;
      left[1]=v2;
      left[2]=v3;

      right_s=1;

      right[0]=v1;
      right[1]=v3;


    }


  calc_right_deltas(right[0],right[1]);
  calc_left_deltas(left[0],left[1]);



  ad=v1->y*screen_w;
  y=v1->y;

  do
    {


      if (y==v2->y)
        {


            if (right_s==2)
              if (calc_right_deltas(right[1],right[2])<0) return;

            if (left_s==2)
              if (calc_left_deltas(left[1],left[2])<0) return;
        }



      if (y>=0) {


        xc1=left_x>>16;
        xc2=right_x>>16;


        if (xc1>=0 && xc2<screen_w)
          {

            asm (

            "


                 movl $0xffff,%%eax;
                 movw %%ax,(%%edi);
                 movw %%ax,(%%ebx);


                 "
             :
             : "D" (scr+((ad+xc1)<<1)),"b" (scr+((ad+xc2)<<1))
             : "%eax", "%ebx", "%ecx", "%edx", "%edi"
            );


          }
          }

        left_x+=left_dx;
        right_x+=right_dx;

        ad+=screen_w;



    } while (y++<y3);


}
/**/
