#define VISIBLE 0
#define SCALE 65536.0
static float scale=65536.0;

__inline__ static long imul16(long x, long y)
{
  long value;

  asm (

  "
  imull %%edx;
  shrdl $16,%%edx,%%eax;

  "

  : "=a" (value)
  : "a" (x), "d" (y)
  : "%eax","%edx"
  );

  return value;
}


__inline__ static long imul14(long x, long y)
{
  long value;

  asm (

  "
  imull %%edx;
  shrdl $14,%%edx,%%eax;

  "

  : "=a" (value)
  : "a" (x), "d" (y)
  : "%eax","%edx"
  );

  return value;

}

__inline__ static long idiv16(long x, long y)
{
  long value;

  asm (

  "
  movl %%eax,%%edx;
  sarl $16,%%edx;
  shll $16,%%eax;
  idivl %%ebx;

  "

  : "=a" (value)
  : "a" (x), "b" (y)
  : "%eax","%edx","%ebx"
  );

  return value;

}

__inline__ static long idiv162(long x, long y)
{
  long value;

  asm (

  "
  movl %%eax,%%edx;
  sarl $16,%%edx;
  idivl %%ebx;

  "

  : "=a" (value)
  : "a" (x), "b" (y)
  : "%eax","%edx","%ebx"
  );

  return value;

}

__inline__ static void fistpUV(long *l, float *x) /* x,y,u,v * scale */
{
  asm (
  "
    flds   (%%ebx);
    fmuls  (_scale);
    fistpl (%%eax);

    flds   4(%%ebx);
    fmuls  (_scale);
    fistpl 4(%%eax);

    flds   8(%%ebx);
    fmuls  (_scale);
    fistpl 8(%%eax);

    flds   12(%%ebx);
    fmuls  (_scale);
    fistpl 12(%%eax);
  "
  :
  : "a" (l),"b" (x)
  : "%eax","%ebx"
  );
}

__inline__ static void fistpL(long *l, float *x) /* x,y,l * scale */
{
  asm (
  "
    flds   (%%ebx);
    fmuls  (_scale);
    fistpl (%%eax);

    flds   4(%%ebx);
    fmuls  (_scale);
    fistpl 4(%%eax);

    flds   24(%%ebx);
    fmuls  (_scale);
    fistpl 24(%%eax);

  "
  :
  : "a" (l),"b" (x)
  : "%eax","%ebx"
  );
}

__inline__ static void fistpLZ(long *l, float *x) /* x,y,l,z * scale */
{
  asm (
  "
    flds   (%%ebx);
    fmuls  (_scale);
    fistpl (%%eax);

    flds   4(%%ebx);
    fmuls  (_scale);
    fistpl 4(%%eax);

    flds   24(%%ebx);
    fmuls  (_scale);
    fistpl 24(%%eax);

    flds   28(%%ebx);
    fmuls  (_scale);
    fistpl 28(%%eax);
  "
  :
  : "a" (l),"b" (x)
  : "%eax","%ebx"
  );
}

__inline__ static void fistpUVZ(long *l, float *x) /* x,y,u,v,z * scale */
{
  asm (
  "
    flds   (%%ebx);
    fmuls  (_scale);
    fistpl (%%eax);

    flds   4(%%ebx);
    fmuls  (_scale);
    fistpl 4(%%eax);

    flds   8(%%ebx);
    fmuls  (_scale);
    fistpl 8(%%eax);

    flds   12(%%ebx);
    fmuls  (_scale);
    fistpl 12(%%eax);

    flds   28(%%ebx);
    fmuls  (_scale);
    fistpl 28(%%eax);
  "
  :
  : "a" (l),"b" (x)
  : "%eax","%ebx"
  );
}

__inline__ static void fistpUVL(long *l, float *x) /* x,y,u,v,ul,vl * scale */
{
  asm (
  "
    flds   (%%ebx);
    fmuls  (_scale);
    fistpl (%%eax);

    flds   4(%%ebx);
    fmuls  (_scale);
    fistpl 4(%%eax);

    flds   8(%%ebx);
    fmuls  (_scale);
    fistpl 8(%%eax);

    flds   12(%%ebx);
    fmuls  (_scale);
    fistpl 12(%%eax);

    flds   16(%%ebx);
    fmuls  (_scale);
    fistpl 16(%%eax);

    flds   20(%%ebx);
    fmuls  (_scale);
    fistpl 20(%%eax);
  "
  :
  : "a" (l),"b" (x)
  : "%eax","%ebx"
  );
}

#define fistp(l,x)             \
  asm (                        \
                               \
  "                            \
                               \
  fldl (%%ebx);               \
  fistpll (%%eax);             \
                               \
  "                            \
  :                            \
  : "a" (l),"b" (x)            \
  : "%eax","%ebx"              \
  );

#define ceil(x) (((x)+0xffff)>>16)

extern int cliptest(t2df *v);
extern int clip(t2df ***out0,t2df *in0);

