#include <stdio.h>
#include <conio.h>
#include "3dtypes.h"
#include "gfx.h"

extern object obj[];
extern int avertices,afaces,aedges,maxobj,maxtex,maxpal;
extern float ob;

extern int  find_s(char *str0,char *str1);
extern void load_asc(char *file_name);
extern void load_3ds(char *file_name);
extern int  load_3dg(char *file_name);
extern int  load_3dg_2_0(char *file_name);
extern void save_3dg(char *file_name);
extern void calc_ob(void);
extern void calc_normals(void);
extern void calc_line_points(void);
extern void center_object(void);
extern void scale_object(float s);
extern float lx,ly,lz,lxx,lyy;

extern void change_texture_pixeldepth_to_16(char *texture, int w, int h);


int using_memory;

char tpath[256];

/**/
void startup(int argc, char *argv[])
{
  char ch;
  int  i,j,r,p,p1,mem;

  textmode(C80);
  textcolor(WHITE);
  textbackground(BLUE);
//  cputs("3D VIEWER V.2.4 (18.05.99) - 15 BIT VERSION - CODE BY HERN.            DGS CO'96");
  cputs("3D VIEWER V.2.5 (03.09.00) - 16 BIT VERSION - CODE BY HERN.            DGS CO'96");
  textbackground(BLACK);
  cputs("                                                                                ");
  maxtex=0;

  mem=_go32_dpmi_remaining_physical_memory();
  printf("Free memory : %d KB\n\n",mem/1024);

  if (argc<2)
    {
      textmode(C80);
      printf("Error: No object file :%s",argv[1]);
      exit(1);

    } else


  {
    ch=0;i=0;
    while (ch != '.') ch=argv[1][i++];

    printf("Loading : %s\n",argv[1]);

    if (argv[1][i]=='a')
      load_asc(argv[1]);       /* asc */

    if (argv[1][i]=='p')       /* prj */
      load_3ds(argv[1]);

    if (argv[1][i]=='3')

      if (argv[1][i+2]=='s')
        load_3ds(argv[1]);     /* 3ds */
      else                     /* 3dg */
      {
        r=load_3dg_2_0(argv[1]);
        if (r==0)
          printf(" 3DG 2.0\n");
        if (r==-2)
          {
            r=load_3dg(argv[1]);
            printf(" 3DG 1.0\n");

          }
        if (r==-1)
          {
            printf("File error.\n");
            exit(1);
          }

      }
  }

  using_memory=0;

  for (i=0;i<maxobj;i++)
     using_memory+=obj[i].vertices*sizeof(v3d)*4+
                   obj[i].vertices*sizeof(p2d)+
                   obj[i].faces*sizeof(v3d)+
                   obj[i].faces*sizeof(f3d)+
                   obj[i].edges*sizeof(l2d);

  using_memory/=1024;



  printf(" Found %d objects\n",maxobj);
  printf(" Total vertices : %d\n",avertices);
  printf(" Total faces    : %d\n",afaces);
  printf("\nObject memory : %d KB\n",using_memory);

  dr=(drs *) calloc (afaces,sizeof(drs));
//  drp=(drs *) malloc(afaces*4);

  p=0;
  if (maxtex>0)
    for (i=0;i<maxtex;i++)
      {
         printf("\nLoading : %s\n",texture[i].filename);
         p1=i-p;

         if (p1<0) p1=0;
         texture[p1].addr=load_tga(texture[i].filename);
         if (texture[i].addr==NULL)
           {

             memset(tpath,0,sizeof(tpath));
             strcat(tpath,"c:\\djgpp\\projects\\3dgs16b\\textures\\");
             strcat(tpath,texture[i].filename);
             texture[p1].addr=load_tga(tpath);

             if (texture[p1].addr==NULL)
               printf("Error loading texture.\n");
             p++;

           }
      }
  maxtex-=p;

  for (i=1;i<argc;i++)

     if ( find_s(".tga",argv[i]) )
       {

         printf("\nLoading : %s\n",argv[i]);
         texture[maxtex].addr=load_tga(argv[i]);
         strcpy(texture[maxtex].filename,argv[i]);
         if (texture[maxtex].addr==NULL)
           {
             memset(tpath,0,sizeof(tpath));
             strcat(tpath,"c:\\djgpp\\projects\\3dgs16b\\textures\\");
             strcat(tpath,argv[i]);
             texture[maxtex].addr=load_tga(tpath);

             if (texture[maxtex].addr==NULL)
               printf("Error loading texture.\n");

           }
         maxtex++;
       }



  for (i=1;i<argc;i++)

     if ( find_s("s3dg",argv[i]) )
       {

         j=0;
         while (argv[1][j] != '.') j++;

         argv[1][j+1]='3';
         argv[1][j+2]='D';
         argv[1][j+3]='G';
         save_3dg(argv[1]);
         printf("\nFile was coverted to 3dgs file format\n\n");


         break;
       }


  if (maxtex>0)
    for (i=0;i<maxtex;i++)

      change_texture_pixeldepth_to_16(texture[i].addr, 256, 256);


  printf("\nAll memory in use : %d KB\n",(_go32_dpmi_remaining_physical_memory())/1024);

//  printf("\nCalculating normals... [          ]\n");
//  scale_object(5);
  printf("\nCalculating normals...\n");
  calc_normals();
  printf("\n");
  printf("Calculating edges...\n");
//  calc_line_points();
//  printf("%d edges\n",aedges);
  printf("Scaling object...\n");
  printf("Setting obsertvator...");
  calc_ob();
  printf("%f\n",ob);
  printf("lx: %f\n",lx);
  printf("ly: %f\n",ly);
  printf("lz: %f\n",lz);
  printf("Centering object...\n");
//  center_object();


}
/**/