#include "3dtypes.h"
#include "poly.h"

#define COL15(r,g,b) \
  ( (r << 10) | (g << 5) | b)
#define MAXCOL COL15(255,255,255)


/**/

extern int screen_w;
extern int screen_h;
extern char *scr;
extern char *texture_rgb;
static char *tex;

static short *screen;


static long u,v_,ul,vl,du,dv,dul,dvl;

static long left_x,right_x;
static long left_dx,right_dx;

static long left_u,left_v_,left_ul,left_vl;
static long left_du,left_dv,left_dul,left_dvl;

static long left_h;
static long right_h;
static long height;
static long width;
static long inv_height;
static long prestep;


static t2d *min_v,*max_v,*end_v,*start_v;
static t2d *right_v,*left_v;
static long maxy,miny;

int col,l;
extern int light[];


/**/
static void calc_right_deltas()
{
  t2d *v1,*v2;

  v1=right_v;

  if (right_v>start_v)
    v2=right_v-1;
  else
    v2=end_v;

  right_v=v2;

  right_h=ceil(v2->y) - ceil(v1->y);

  if (right_h<=0) return;

  prestep = (ceil(v1->y) << 16) - v1->y;

  if (right_h>1)
    {
      height=v2->y - v1->y;
      right_dx = idiv16( v2->x - v1->x , height);
    }
  else
    {
      inv_height = (0x10000 << 14) / (v2->y - v1->y);
      right_dx = imul14(v2->x - v1->x, inv_height);

    }

  right_x  = v1->x + imul16(prestep,right_dx);

  return;

}
/**/
static void calc_left_deltas()
{

  t2d *v1,*v2;

  v1=left_v;

  if (left_v<end_v)
    v2=left_v+1;
  else
    v2=start_v;

  left_v=v2;


  left_h=ceil(v2->y) - ceil(v1->y);

  if (left_h<=0) return;

  prestep = (ceil(v1->y) << 16) - v1->y;

  if (left_h>1)
    {

      height=v2->y - v1->y;
      left_dx  = idiv16( v2->x - v1->x , height);
      left_du  = idiv16( v2->u - v1->u , height);
      left_dv  = idiv16( v2->v - v1->v , height);
      left_dul = idiv16( v2->ul - v1->ul , height);
      left_dvl = idiv16( v2->vl - v1->vl , height);
    }
  else
    {
      inv_height = (0x10000 << 14) / (v2->y - v1->y);
      left_dx = imul14(v2->x - v1->x, inv_height);
      left_du = imul14(v2->u - v1->u, inv_height);
      left_dv = imul14(v2->v - v1->v, inv_height);
      left_dul = imul14( v2->ul - v1->ul , inv_height);
      left_dvl = imul14( v2->vl - v1->vl , inv_height);
    }
    
  left_x=v1->x  + imul16(prestep,left_dx);
  left_u=v1->u  + imul16(prestep,left_du);
  left_v_=v1->v + imul16(prestep,left_dv);
  left_ul=v1->ul + imul16(prestep,left_dul);
  left_vl=v1->vl + imul16(prestep,left_dvl);

  return;

}
/**/
void draw_texture_phong_light_poly(t2d *va,int vertices,char *texture,char *light)
{

  t2d *v0;

  long x1;

  int i;
  int ad;
  int c1,c2,c3,col0;



  start_v = va;
  min_v   = va;
  max_v   = va;


  miny=va->y;
  maxy=va->y;

  v0      = va+1;

  for (i=1;i<vertices;i++)
    {

      if (v0->y<miny)
        {
          miny=v0->y;
          min_v=v0;
        } else
      if (v0->y>maxy)
        {
  
          maxy=v0->y;
          max_v=v0;
        }
      v0++;
    }

  end_v   = v0-1;
  left_v  = min_v;
  right_v = min_v;




  do {

      if (right_v == max_v)
        return;
      calc_right_deltas();
  } while (right_h<=0);

  do {

      if (left_v == max_v)
        return;
      calc_left_deltas();
  } while (left_h<=0);



  tex=texture;

  ad=ceil(min_v->y)*screen_w;


  for (;;)
    {

        x1 = ceil(left_x);
        width = ceil(right_x) - x1;


        if (width>0)
          {

            prestep = (x1 << 16) - left_x;
            u = left_u  + imul16(prestep, du);
            v_= left_v_ + imul16(prestep, dv);
            ul= left_ul + imul16(prestep, dul);
            vl= left_vl + imul16(prestep, dvl);

                                        //(u*6+b)/6=u+b/6;
            screen=(short *) scr+ad+x1;
            while (width--)

              {
                col=*( (short*) texture+((v_>>16)<<8)+(u>>16));
                l=*( light+((vl>>16)<<8)+(ul>>16));

                c1=( (col>>10) & 0x1f )+l;
                c2=( (col>>05) & 0x1f )+l;
                c3=( (col>>00) & 0x1f )+l;


/*                c1=texture_rgb[col];
                c2=texture_rgb[col+1];
                c3=texture_rgb[col+2];*/

                if (c1>31) c1=31;
                if (c2>31) c2=31;
                if (c3>31) c3=31;

                col0=COL15(c1,c2,c3);


                *screen++=col0;

                u+=du;
                v_+=dv;
                ul+=dul;
                vl+=dvl;
              }

          }


        if (--right_h<=0)
        do {
      
            if (right_v == max_v)
              return;
            calc_right_deltas();
      
        } while (right_h<=0);

          else

        right_x+=right_dx;


        if (--left_h<=0)
        do {
      
            if (left_v == max_v)
              return;
            calc_left_deltas();
        } while (left_h<=0);

          else
        {
          left_x+=left_dx;
          left_u+=left_du;
          left_v_+=left_dv;
          left_ul+=left_dul;
          left_vl+=left_dvl;
        }


        ad+=screen_w;



    }


}
/**/
void draw_texture_phong_light_triangle(t2df *va,char *texture,char *light)
{
  t2df *v1=va;
  t2df *v2=va+1;
  t2df *v3=va+2;

  static t2d  vx[12];
  static t2df **dst,*t;


  double dy1,dy2;
  double d,id;
  int    i,max;

  double  ddu,ddv,ddul,ddvl;


  v1->visible=cliptest(v1);
  v2->visible=cliptest(v2);
  v3->visible=cliptest(v3);

  if ( (v1->visible & v2->visible & v3->visible) != VISIBLE )
    return;



  dy1=v2->y - v3->y;
  dy2=v1->y - v3->y;

  d = (v1->x - v3->x) * dy1 -
      (v2->x - v3->x) * dy2;

  if (d == 0.0) return;

  id = 1.0/d*65536.0;

  ddu  = ( (v1->u - v3->u) * dy1 - (v2->u - v3->u) * dy2 ) *id ;
  ddv  = ( (v1->v - v3->v) * dy1 - (v2->v - v3->v) * dy2 ) *id ;
  ddul = ( (v1->ul - v3->ul) * dy1 - (v2->ul - v3->ul) * dy2 ) *id ;
  ddvl = ( (v1->vl - v3->vl) * dy1 - (v2->vl - v3->vl) * dy2 ) *id ;


  max=3;

  if ( ( (v1->visible | v2->visible | v3->visible) & 0xff )== VISIBLE )
    {

      fistpUVL(&vx[0].x,&v1->x);
      fistpUVL(&vx[1].x,&v2->x);
      fistpUVL(&vx[2].x,&v3->x);
    }
  else
    {
      max=clip(&dst,va);
      if (max<3) return;

      for (i=0;i<max;i++)
        fistpUVL(&vx[i].x,&dst[i]->x);
    }

  fistp(&du,&ddu);
  fistp(&dv,&ddv);
  fistp(&dul,&ddul);
  fistp(&dvl,&ddvl);

  draw_texture_phong_light_poly(vx,max,texture,light);


}

/**/
