#include "3dtypes.h"
/**/
// naklada dwie bitmapy na siebie

#define COL15(r,g,b) \
  ( (r << 10) | (g << 5) | b)
#define MAXCOL COL15(255,255,255)

extern int screen_w;
extern int screen_h;
extern char *scr;
static char *tex;


static int u,v_,ul,vl,du,dv,dul,dvl;

static t2d  *right[3];
static t2d  *left[3];

static int  left_s,right_s;
static int  x;

static int left_x,right_x;
static int left_dx,right_dx;

static int left_u,left_v;
static int left_du,left_dv;
static int left_dul,left_dvl;
static int left_ul,left_vl;

/**/
static int calc_right_deltas(t2d *v1, t2d *v2)
{
  int dy;

  dy=v2->y - v1->y;

  if (right_s==0) return -1;
  if (dy==0) return -1;

  right_dx = ( ( v2->x - v1->x ) << 16 ) / dy;
  right_x=v1->x<<16;

  return 0;

}

static int calc_left_deltas(t2d *v1, t2d *v2)
{

  int dy;

  dy=v2->y - v1->y;

  if (left_s==0) return -1;
  if (dy==0) return -1;

  left_dx  = ( ( v2->x - v1->x ) << 16 ) / dy;
  left_du  = ( ( v2->u - v1->u ) << 16 ) / dy;
  left_dv  = ( ( v2->v - v1->v ) << 16 ) / dy;
  left_dul = ( ( v2->ul - v1->ul ) << 16 ) / dy;
  left_dvl = ( ( v2->vl - v1->vl ) << 16 ) / dy;


  left_x=v1->x<<16;
  left_u=v1->u<<16;
  left_v=v1->v<<16;
  left_ul=v1->ul<<16;
  left_vl=v1->vl<<16;

  return 0;

}
/**/
int draw_twice_texture_triangle(t2d *va,char *texture,char *light)
{


  t2d *v1=va;
  t2d *v2=va+1;
  t2d *v3=va+2;

  int dx,dy;
  int xc1,xc2;
  int t,y,y3;
  int ad,ad1;
  int w,h;
  int col,col0,c1,c2,c3;
  int l,l1,l2,l3;
  double d,id;

  int min_x,max_x;

  char *screen;
  t2d  *v;

  int dy1,dy2;

  if (v1->y > v3->y) { v=v1;v1=v3;v3=v; }
  if (v2->y > v3->y) { v=v2;v2=v3;v3=v; }
  if (v1->y > v2->y) { v=v1;v1=v2;v2=v; }


  w=screen_w-1;
  h=screen_h-1;

  if (v3->y<0)        return;
  if (v1->y>h)        return;
  if (v3->y-v1->y==0) return;
  if (v3->y>h)        y3=h;else y3=v3->y;

  min_x=v1->x;
  if (v2->x<min_x) min_x=v2->x;
  if (v3->x<min_x) min_x=v3->x;

  max_x=v1->x;
  if (v2->x>max_x) max_x=v2->x;
  if (v3->x>max_x) max_x=v3->x;

  if (max_x<0) return;
  if (min_x>w) return;


  dy1=v2->y - v3->y;
  dy2=v1->y - v3->y;

  d = (v1->x - v3->x) * dy1 -
      (v2->x - v3->x) * dy2;

  if(d == 0.0) return;

  id = 1.0/d * 65535.0;

  du = ((v1->u - v3->u) * dy1 -
        (v2->u - v3->u) * dy2) * id;
  dv = ((v1->v - v3->v) * dy1 -
        (v2->v - v3->v) * dy2) * id;

  dul= ((v1->ul - v3->ul) * dy1 -
        (v2->ul - v3->ul) * dy2) * id;
  dvl= ((v1->vl - v3->vl) * dy1 -
        (v2->vl - v3->vl) * dy2) * id;


  if (d>0)
    {
      right_s=2;
      right[0]=v1;
      right[1]=v2;
      right[2]=v3;

      left_s=1;

      left[0]=v1;
      left[1]=v3;

    }
  else
    {
      left_s=2;
      left[0]=v1;
      left[1]=v2;
      left[2]=v3;

      right_s=1;

      right[0]=v1;
      right[1]=v3;


    }


  calc_right_deltas(right[0],right[1]);
  calc_left_deltas(left[0],left[1]);

  tex=texture;

  ad=v1->y*screen_w;
  y=v1->y;

  do
    {


      if (y==v2->y)
        {


            if (right_s==2)
              if (calc_right_deltas(right[1],right[2])<0) return;

            if (left_s==2)
              if (calc_left_deltas(left[1],left[2])<0) return;
        }



      if (y>=0) {


        xc1=left_x>>16;
        xc2=right_x>>16;

        u=left_u;
        v_=left_v;
        ul=left_ul;
        vl=left_vl;


        if (xc1<0)
          {

            u+=du*(-xc1);
            v_+=dv*(-xc1);
            ul+=dul*(-xc1);
            vl+=dvl*(-xc1);
            xc1=0;
          }


        if (xc2>screen_w) xc2=screen_w;

        dx=xc2-xc1;

        if (dx>0)
          {
                                        //(u*6+b)/6=u+b/6;
            ad1=ad+xc1;
            while (dx--)

              {
                col=*( (short*) texture+((v_>>16)<<8)+(u>>16));
                  l=*( (short*) light+((vl>>16)<<8)+(ul>>16));

                c1=( (col>>10) & 0x1f );
                c2=( (col>>05) & 0x1f );
                c3=( (col>>00) & 0x1f );

                l1=( (l>>10) & 0x1f );
                l2=( (l>>05) & 0x1f );
                l3=( (l>>00) & 0x1f );


                c1+=l1; if (c1>31) c1=31;
                c2+=l2; if (c2>31) c2=31;
                c3+=l3; if (c3>31) c3=31;

                col0=COL15(c1,c2,c3);


                *( (short*) scr+ad1)=col0;

                u+=du;
                v_+=dv;
                ul+=dul;
                vl+=dvl;
                ad1++;


              }

          }
          }

        left_x+=left_dx;
        left_u+=left_du;
        left_v+=left_dv;
        left_ul+=left_dul;
        left_vl+=left_dvl;

        right_x+=right_dx;

        ad+=screen_w;



    } while (y++<y3);


}
/**/
