#include "3dtypes.h"
#include "poly.h"

/**/

extern int screen_w;
extern int screen_h;
extern char *scr;
static char *tex;

static short *screen;

static float u,v_,z,du,dv,dz;


static float left_x,right_x;
static float left_dx,right_dx;

static float left_u,left_v_,left_z;
static float left_du,left_dv,left_dz;

static float right_u,right_v_,right_z;
static float right_du,right_dv,right_dz;

static float left_h;
static float right_h;
static float height;
static float width;


static t2df  *min_v,*max_v,*end_v,*start_v;
static t2df  *right_v,*left_v;
static float maxy,miny;


/**/
static void calc_right_deltas()
{
  t2df *v1,*v2;

  v1=right_v;

  if (right_v>start_v)
    v2=right_v-1;
  else
    v2=end_v;

  right_v=v2;


  height=v2->y - v1->y;

  right_h=height;

  if (right_h<=0.0) return;

  right_dx = ( v2->x - v1->x ) / height;
  right_du = ( v2->u - v1->u ) / height;
  right_dv = ( v2->v - v1->v ) / height;
  right_dz = ( v2->z - v1->z ) / height;

  right_x = v1->x;
  right_u = v1->u;
  right_v_ = v1->v;
  right_z = v1->z;

  return;

}
/**/
static void calc_left_deltas()
{

  t2df *v1,*v2;


  v1=left_v;

  if (left_v<end_v)
    v2=left_v+1;
  else
    v2=start_v;

  left_v=v2;


  height=v2->y - v1->y;

  left_h=height;

  if (left_h<=0.0) return;

  left_dx  = ( v2->x - v1->x ) / height;
  left_du  = ( v2->u - v1->u ) / height;
  left_dv  = ( v2->v - v1->v ) / height;
  left_dz  = ( v2->z - v1->z ) / height;
    
  left_x=v1->x  ;
  left_u=v1->u  ;
  left_v_=v1->v ;
  left_z=v1->z  ;

  return;

}
/**/
#define fist(l,x)             \
  asm (                        \
                               \
  "                            \
                               \
  fldl (%%ebx);               \
  fistpl (%%eax);             \
                               \
  "                            \
  :                            \
  : "a" (l),"b" (x)            \
  : "%eax","%ebx"              \
  );
/**/
void draw_texture_poly_perspective_f(t2df *va,int vertices,char *texture)
{

  t2df *v0;

  long x1;
  float u1,v1,z1;
  double t1z;


  double fu,fv;

  int i;
  int ad,ad1,tad,uu1,vv1;




  start_v = va;
  min_v   = va;
  max_v   = va;


  miny=va->y;
  maxy=va->y;

  v0      = va+1;

  for (i=1;i<vertices;i++)
    {

      if (v0->y<miny)
        {
          miny=v0->y;
          min_v=v0;
        } else
      if (v0->y>maxy)
        {
  
          maxy=v0->y;
          max_v=v0;
        }
      v0++;
    }

  end_v   = v0-1;
  left_v  = min_v;
  right_v = min_v;




  do {

      if (right_v == max_v)
        return;
      calc_right_deltas();
  } while (right_h<=0);

  do {

      if (left_v == max_v)
        return;
      calc_left_deltas();
  } while (left_h<=0);



  tex=texture;
  screen=(short *)scr;

  ad=(int)(min_v->y+0.0)*screen_w;


  for (;;)
    {

        x1=(int)left_x;

        width = (right_x - left_x);


        if (width>0.0)
          {

            u = left_u ;
            v_= left_v_;
            z = left_z ;



            du = (right_u  - left_u ) / width;
            dv = (right_v_ - left_v_) / width;
            dz = (right_z  - left_z ) / width;

            ad1=ad+x1;

            while (width-->0.0)
              {

/*
                if (z!=0) {



                t1z=1.0/(double)z;

                fu=u*t1z;
                fv=v_*t1z*256.0;



                fist(&uu1,&fu);
                fist(&vv1,&fv);

                tad=uu1+vv1;

                if (tad>=0 && tad<=255*255)

                  *((short *) scr+ad1)=*((short *) texture + tad);

                           }
                u+=du;
                v_+=dv;
                z+=dz;*/
                  *((short *) scr+ad1)=0xffff;
                ad1++;
              }


          }


        if (--right_h<=0)
        do {
      
            if (right_v == max_v)
              return;
            calc_right_deltas();
      
        } while (right_h<=0);

          else
        {

        right_x+=right_dx;
        right_u+=right_du;
        right_v_+=right_dv;
        right_z+=right_dz;
        }


        if (--left_h<=0)
        do {
      
            if (left_v == max_v)
              return;
            calc_left_deltas();
        } while (left_h<=0);

          else
        {
          left_x+=left_dx;
          left_u+=left_du;
          left_v_+=left_dv;
          left_z+=left_dz;
        }


        ad+=screen_w;



    }


}
/**/
void draw_texture_triangle_perspective_f(t2df *va,char *texture)
{
  t2df *v1=va;
  t2df *v2=va+1;
  t2df *v3=va+2;

  static t2df vx[12];
  static t2df **dst,*t;


  double dy1,dy2;
  double d,id;
  int    i,max;

  double  ddu,ddv,ddz,z1,z2,z3,ut1,ut2,ut3,vt1,vt2,vt3,Zd;


  v1->visible=cliptest(v1);
  v2->visible=cliptest(v2);
  v3->visible=cliptest(v3);

  if ( (v1->visible & v2->visible & v3->visible) != VISIBLE )
    return;



  dy1=v2->y - v3->y;
  dy2=v1->y - v3->y;

  d = (v1->x - v3->x) * dy1 -
      (v2->x - v3->x) * dy2;

  if (d == 0.0) return;

  id = 1.0/d;


  z1=v1->z;
  z2=v2->z;
  z3=v3->z;

  du = ( (v1->u - v3->u) * dy1 - (v2->u - v3->u) * dy2 ) *id ;
  dv = ( (v1->v - v3->v) * dy1 - (v2->v - v3->v) * dy2 ) *id ;
  dz = ( (v1->z - v3->z) * dy1 - (v2->z - v3->z) * dy2 ) *id ;



  max=3;

  if ( ( (v1->visible | v2->visible | v3->visible) & 0xff )== VISIBLE )
    {


      vx[0].z=1.0/v1->z;
      vx[1].z=1.0/v2->z;
      vx[2].z=1.0/v3->z;



      vx[0].u=(v1->u/z1);
      vx[0].v=(v1->v/z1);
      vx[1].u=(v2->u/z2);
      vx[1].v=(v2->v/z2);
      vx[2].u=(v3->u/z3);
      vx[2].v=(v3->v/z3);


      vx[0].x=v1->x+0.0;
      vx[1].x=v2->x+0.0;
      vx[2].x=v3->x+0.0;

      vx[0].y=v1->y+0.0;
      vx[1].y=v2->y+0.0;
      vx[2].y=v3->y+0.0;

    }

  draw_texture_poly_perspective_f(vx,max,texture);


}

