#include "3dtypes.h"
#include "poly.h"

static float Scale=65536.0;
/**/
__inline__ static void fistp1UVZ(long *l, float *x) /* x,y,u,v,z * scale */
{
  asm (
  "
    flds   (%%ebx);
    fmuls  (_Scale);
    fistpl (%%eax);

    flds   4(%%ebx);
    fmuls  (_Scale);
    fistpl 4(%%eax);

  "
  :
  : "a" (l),"b" (x)
  : "%eax","%ebx"
  );
}
/**/

extern int screen_w;
extern int screen_h;
extern char *scr;
static char *tex;

static short *screen;

static long u,v_,z,du,dv,dz;


static long left_x,left_z,right_x;
static long left_dx,right_dx;

static long left_u,left_v_,left_z;
static long left_du,left_dv,left_dz;

static long left_h;
static long right_h;
static long height;
static long width;
static long inv_height;
static long prestep;


static t2d *min_v,*max_v,*end_v,*start_v;
static t2d *right_v,*left_v;
static long maxy,miny;

static long limit;

/**/
static void calc_right_deltas()
{
  t2d *v1,*v2;

  v1=right_v;

  if (right_v>start_v)
    v2=right_v-1;
  else
    v2=end_v;

  right_v=v2;

  right_h=ceil(v2->y) - ceil(v1->y);

  if (right_h<=0) return;

  prestep = (ceil(v1->y) << 16) - v1->y;

  if (right_h>1)
    {
      height=v2->y - v1->y;
      right_dx = idiv16( v2->x - v1->x , height);
    }
  else
    {
      inv_height = (0x10000 << 14) / (v2->y - v1->y);
      right_dx = imul14(v2->x - v1->x, inv_height);

    }

  right_x  = v1->x + imul16(prestep,right_dx);

  return;

}
/**/
static void calc_left_deltas()
{

  t2d *v1,*v2;


  v1=left_v;

  if (left_v<end_v)
    v2=left_v+1;
  else
    v2=start_v;

  left_v=v2;


  left_h=ceil(v2->y) - ceil(v1->y);

  if (left_h<=0) return;

  prestep = (ceil(v1->y) << 16) - v1->y;

  if (left_h>1)
    {

      height=v2->y - v1->y;



      left_dx  = idiv16( v2->x - v1->x , height);
      left_du  = idiv16( v2->u - v1->u , height);
      left_dv  = idiv16( v2->v - v1->v , height);
      left_dz  = idiv16( v2->z - v1->z , height);
    }
  else
    {
      inv_height = (0x10000 << 14) / (v2->y - v1->y);
      left_dx = imul14(v2->x - v1->x, inv_height);
      left_du = imul14(v2->u - v1->u, inv_height);
      left_dv = imul14(v2->v - v1->v, inv_height);
      left_dz = imul14(v2->z - v1->z, inv_height);
    }
    
  left_x=v1->x  + imul16(prestep,left_dx);
  left_u=v1->u  + imul16(prestep,left_du);
  left_v_=v1->v + imul16(prestep,left_dv);
  left_z=v1->z + imul16(prestep,left_dz);

  return;

}
/**/
inline static long idiv(long x, long y)
{
  long value;

  asm volatile (

  "
  sarl $16,%%ebx
  cltd
  idivl %%ebx

  "

  : "=a" (value)
  : "a" (x), "b" (y)
  : "%eax","%edx","%ebx"
  );

  return value;

}
/**/
void draw_texture_poly_perspective(t2d *va,int vertices,char *texture)
{

  t2d *v0;

  long x1;
  long u1,v1,z1,tet;


  double fu,fv;

  int i;
  int ad,ad1;




  start_v = va;
  min_v   = va;
  max_v   = va;


  miny=va->y;
  maxy=va->y;

  v0      = va+1;

  for (i=1;i<vertices;i++)
    {

      if (v0->y<miny)
        {
          miny=v0->y;
          min_v=v0;
        } else
      if (v0->y>maxy)
        {
  
          maxy=v0->y;
          max_v=v0;
        }
      v0++;
    }

  end_v   = v0-1;
  left_v  = min_v;
  right_v = min_v;




  do {

      if (right_v == max_v)
        return;
      calc_right_deltas();
  } while (right_h<=0);

  do {

      if (left_v == max_v)
        return;
      calc_left_deltas();
  } while (left_h<=0);



  tex=texture;
  screen=(short *)scr;

  ad=ceil(min_v->y)*screen_w;


  for (;;)
    {

        x1 = ceil(left_x);
        width = ceil(right_x) - x1;


        if (width>0)
          {

            prestep = (x1 << 16) - left_x;
            u = left_u  + imul16(prestep, du);
            v_= left_v_ + imul16(prestep, dv);
            z = left_z  + imul16(prestep, dz);

            ad1=ad+x1;

            while (width--)
              {


                if ((z>>16)!=0) {




//                u1=u/z;
  //              v1=v_/z;

                u1=idiv162(u,z>>16);
                v1=idiv162(v,z>>16);

                tet=((v1>>16)<<8)+(u1<<16);


                if (v1>=0 && v1<=255 && u1>=0 && u1<=255)
                *((short *) scr+ad1)=*((short *) texture +tet);

                           }
    //            else
      //          *((short *) scr+ad1)=0xffff;

                u+=du;
                v_+=dv;
                z+=dz;
                ad1++;
              }


          }


        if (--right_h<=0)
        do {
      
            if (right_v == max_v)
              return;
            calc_right_deltas();
      
        } while (right_h<=0);

          else

        right_x+=right_dx;


        if (--left_h<=0)
        do {
      
            if (left_v == max_v)
              return;
            calc_left_deltas();
        } while (left_h<=0);

          else
        {
          left_x+=left_dx;
          left_u+=left_du;
          left_v_+=left_dv;
          left_z+=left_dz;
        }


        ad+=screen_w;



    }


}
/**/
void draw_texture_triangle_perspective(t2df *va,char *texture)
{
  t2df *v1=va;
  t2df *v2=va+1;
  t2df *v3=va+2;

  static t2d  vx[12];
  static t2df **dst,*t;


  double dy1,dy2;
  double d,id;
  int    i,max;

  double  ddu,ddv,ddz,z1,z2,z3,ut1,ut2,ut3,vt1,vt2,vt3,Zd;


  v1->visible=cliptest(v1);
  v2->visible=cliptest(v2);
  v3->visible=cliptest(v3);

  if ( (v1->visible & v2->visible & v3->visible) != VISIBLE )
    return;



  dy1=v2->y - v3->y;
  dy2=v1->y - v3->y;

  d = (v1->x - v3->x) * dy1 -
      (v2->x - v3->x) * dy2;

  if (d == 0.0) return;

  id = 1.0/d*65536.0;


  z1=1.0/v1->z;
  z2=1.0/v2->z;
  z3=1.0/v3->z;

  ut1=v1->u*z1;
  ut2=v2->u*z2;
  ut3=v3->u*z3;

  vt1=v1->v*z1;
  vt2=v2->v*z2;
  vt3=v3->v*z3;


  v1->u=ut1;
  v2->u=ut2;
  v3->u=ut3;
  v1->v=vt1;
  v2->v=vt2;
  v3->v=vt3;
  v1->z=z1;
  v2->z=z2;
  v3->z=z3;


  ddu = ( (ut1 - ut3) * dy1 - (ut2 - ut3) * dy2 ) *id ;
  ddv = ( (vt1 - vt3) * dy1 - (vt2 - vt3) * dy2 ) *id ;
  ddz = ( (z1  -  z3) * dy1 - (z2  -  z3) * dy2 ) *id ;

  /*
  Zd=z1*z2*z3*d;

  ddu=( z2*(ut1*z3-ut3*z1)*dy1-z1*(ut2*z3-ut3*z2)*dy2 ) / Zd * 65536.0;
  ddv=( z2*(vt1*z3-vt3*z1)*dy1-z1*(vt2*z3-vt3*z2)*dy2 ) / Zd * 65536.0;
  ddz=( dy1*(z2*z3-z1*z2)-dy2*(z1*z3-z1*z2) ) / Zd * 65536.0;*/


  max=3;

  if ( ( (v1->visible | v2->visible | v3->visible) & 0xff )== VISIBLE )
    {


/*      fistp(&vx[0].z,&z1);
      fistp(&vx[1].z,&z2);
      fistp(&vx[2].z,&z3);
      fistp(&vx[0].u,&ut1);
      fistp(&vx[1].u,&ut2);
      fistp(&vx[2].u,&ut3);
      fistp(&vx[0].v,&vt1);
      fistp(&vx[1].v,&vt2);
      fistp(&vx[2].v,&vt3);*/

      fistpUVZ(&vx[0].x,&v1->x);
      fistpUVZ(&vx[1].x,&v2->x);
      fistpUVZ(&vx[2].x,&v3->x);


    }
  else
    {
      max=clip(&dst,va);
      if (max<3) return;

      for (i=0;i<max;i++)
        fistpUVZ(&vx[i].x,&dst[i]->x);
    }

  fistp(&du,&ddu);
  fistp(&dv,&ddv);
  fistp(&dz,&ddz);

  draw_texture_poly_perspective(vx,max,texture);


}

