#include "3dtypes.h"
/**/

extern int screen_w;
extern int screen_h;
extern char *scr;
extern char *texture;

static long u,v_,du,dv;

static t2df  *right[3];
static t2df  *left[3];

static int  left_s,right_s;
static int  x;

static long left_x,right_x;
static long left_dx,right_dx;

static long left_u,left_v;
static long left_du,left_dv;
static long dx,dy;
static long prestep;
static long h;

/**/
__inline__ long ceil(long x)
{
  x += 0xffff;
  return x >> 16;
}
/**/
static int calc_right_deltas(t2df *v1, t2df *v2)
{
  long dy;

  dy=ceil(v2->y) - ceil(v1->y);

  if (right_s==0) return -1;
  if (dy==0) return -1;

  h = v2->y - v1->y;
  right_dx = ( (int)( v2->x - v1->x ) << 16 ) / h;

  prestep = (ceil(v1->y*65535.0) << 16) - v1->y;
  right_x = v1->x + ((long)(prestep * right_dx) >> 16);

  return 0;

}

static int calc_left_deltas(t2df *v1, t2df *v2)
{

  long dy;

  dy=ceil(v2->y) - ceil(v1->y);

  if (left_s==0) return -1;
  if (dy==0) return -1;

  h = v2->y - v1->y;

  left_dx  = ( (int) ( v2->x - v1->x ) << 16 ) / h;
  left_du  = ( (int) ( v2->u - v1->u ) << 16 ) / h;
  left_dv  = ( (int) ( v2->v - v1->v ) << 16 ) / h;

  prestep = (ceil(v1->y*65535.0) << 16) - v1->y;

  left_x = v1->x + ((long)(prestep * left_dx) >> 16);
  left_u = v1->u + ((long)(prestep * left_du) >> 16);
  left_v = v1->v + ((long)(prestep * left_dv) >> 16);

  return 0;

}
/**/
int draw_texture_triangle(t2df *va)
{

  t2df *v1=va;
  t2df *v2=va+1;
  t2df *v3=va+2;

  long xc1,xc2;
  int t,y,y3;
  int ad;
  int w,h;
  double d,id;

  float min_x,max_x;

  char *screen;
  t2df  *v;

  float dy1,dy2;

  if (v1->y > v3->y) { v=v1;v1=v3;v3=v; }
  if (v2->y > v3->y) { v=v2;v2=v3;v3=v; }
  if (v1->y > v2->y) { v=v1;v1=v2;v2=v; }


  w=screen_w;
  h=screen_h;

  if (v3->y<0)        return;
  if (v1->y>h)        return;
  if (v3->y-v1->y==0) return;
  if (v3->y>h)        y3=h;else y3=v3->y;

  min_x=v1->x;
  if (v2->x<min_x) min_x=v2->x;
  if (v3->x<min_x) min_x=v3->x;

  max_x=v1->x;
  if (v2->x>max_x) max_x=v2->x;
  if (v3->x>max_x) max_x=v3->x;

  if (max_x<0) return;
  if (min_x>w) return;


  dy1=v2->y - v3->y;
  dy2=v1->y - v3->y;

  d = (v1->x - v3->x) * dy1 -
      (v2->x - v3->x) * dy2;

  if(d == 0.0) return;

  id = 1.0/d * 65535.0;

  du = ((v1->u - v3->u) * dy1 -
        (v2->u - v3->u) * dy2) * id;
  dv = ((v1->v - v3->v) * dy1 -
        (v2->v - v3->v) * dy2) * id;

  if (d>0)
    {
      right_s=2;
      right[0]=v1;
      right[1]=v2;
      right[2]=v3;

      left_s=1;

      left[0]=v1;
      left[1]=v3;

    }
  else
    {
      left_s=2;
      left[0]=v1;
      left[1]=v2;
      left[2]=v3;

      right_s=1;

      right[0]=v1;
      right[1]=v3;


    }


  calc_right_deltas(right[0],right[1]);
  calc_left_deltas(left[0],left[1]);



  ad=v1->y*screen_w;
  y=v1->y;

  do
    {


      if (y==v2->y)
        {


            if (right_s==2)
              if (calc_right_deltas(right[1],right[2])<0) return;

            if (left_s==2)
              if (calc_left_deltas(left[1],left[2])<0) return;
        }



      if (y>=0) {


        xc1=ceil(left_x);
        xc2=right_x>>16;

        u=left_u;
        v_=left_v;

        /*
        if (xc1<0)
          {

            u+=du*(-xc1);
            v_+=dv*(-xc1);
            xc1=0;
          }


        if (xc2>w) xc2=w;*/

        dx=ceil(xc2)-xc1;

        if (dx>0)
          {


            prestep = (xc1 << 16) - left_x;
            u  = left_u + ((prestep * du) >> 16);
            v_ = left_v + ((prestep * dv) >> 16);

            asm (

            "

                 pushl %%ebp;

                 movl _du,%%ebp;
                 movl _dv,%%esi;
                 movl _v_,%%ebx;
                 movl _u,%%eax;


                 lea   (%%edi,%%ecx),%%edi;
                 xor $-1,%%ecx;
                 incl %%ecx;


            n_x:
                 rorl $16,%%ebx;

                 movb %%bh,%%dl;
                 movb %%bl,%%dh;

                 rorl $16,%%ebx;

                 rorl $16,%%eax;
                 addw %%ax,%%dx;
                 rorl $16,%%eax;



                 addl %%ebp,%%eax;
                 addl %%esi,%%ebx;



                 movb (%%edx),%%dl;
                 movb %%dl,(%%edi,%%ecx);


                 incl %%ecx;
                 jnz n_x;

                 popl %%ebp;

                 "
             :
             : "d" (texture), "D" (scr+ad+xc1), "c" (dx)
             : "%eax", "%ebx", "%ecx", "%edx", "%esi", "%edi", "%ebp"
            );

          }
          }

        left_x+=left_dx;
        left_u+=left_du;
        left_v+=left_dv;

        right_x+=right_dx;

        ad+=screen_w;



    } while (y++<y3);


}
/**/
