#include "3dtypes.h"
#include "poly.h"

/**/

extern int screen_w;
extern int screen_h;
extern char *scr;
static char *tex;
extern long  *zbuff;

static long  *zb;
static short *screen;

static long u,v_,z,du,dv,dz;


static long left_x,right_x;
static long left_dx,right_dx;

static long left_u,left_v_,left_z;
static long left_du,left_dv,left_dz;

static long left_h;
static long right_h;
static long height;
static long width;
static long inv_height;
static long prestep;


static t2d *min_v,*max_v,*end_v,*start_v;
static t2d *right_v,*left_v;
static long maxy,miny;


/**/
static void calc_right_deltas()
{
  t2d *v1,*v2;

  v1=right_v;

  if (right_v>start_v)
    v2=right_v-1;
  else
    v2=end_v;

  right_v=v2;

  right_h=ceil(v2->y) - ceil(v1->y);

  if (right_h<=0) return;

  prestep = (ceil(v1->y) << 16) - v1->y;

  if (right_h>1)
    {
      height=v2->y - v1->y;
      right_dx = idiv16( v2->x - v1->x , height);
    }
  else
    {
      inv_height = (0x10000 << 14) / (v2->y - v1->y);
      right_dx = imul14(v2->x - v1->x, inv_height);

    }

  right_x  = v1->x + imul16(prestep,right_dx);

  return;

}
/**/
static void calc_left_deltas()
{

  t2d *v1,*v2;

  v1=left_v;

  if (left_v<end_v)
    v2=left_v+1;
  else
    v2=start_v;

  left_v=v2;


  left_h=ceil(v2->y) - ceil(v1->y);

  if (left_h<=0) return;

  prestep = (ceil(v1->y) << 16) - v1->y;

  if (left_h>1)
    {

      height=v2->y - v1->y;
      left_dx  = idiv16( v2->x - v1->x , height);
      left_du  = idiv16( v2->u - v1->u , height);
      left_dv  = idiv16( v2->v - v1->v , height);
      left_dz  = idiv16( v2->z - v1->z , height);
    }
  else
    {
      inv_height = (0x10000 << 14) / (v2->y - v1->y);
      left_dx = imul14(v2->x - v1->x, inv_height);
      left_du = imul14(v2->u - v1->u, inv_height);
      left_dv = imul14(v2->v - v1->v, inv_height);
      left_dz = imul14(v2->z - v1->z, inv_height);
    }
    
  left_x=v1->x  + imul16(prestep,left_dx);
  left_u=v1->u  + imul16(prestep,left_du);
  left_v_=v1->v + imul16(prestep,left_dv);
  left_z=v1->z  + imul16(prestep,left_dz);

  return;

}
/**/
void draw_texture_poly_zbuffer(t2d *va,int vertices,char *texture)
{

  t2d *v0;

  long x1;

  int i;
  int ad,ad1;




  start_v = va;
  min_v   = va;
  max_v   = va;


  miny=va->y;
  maxy=va->y;

  v0      = va+1;

  for (i=1;i<vertices;i++)
    {

      if (v0->y<miny)
        {
          miny=v0->y;
          min_v=v0;
        } else
      if (v0->y>maxy)
        {
  
          maxy=v0->y;
          max_v=v0;
        }
      v0++;
    }

  end_v   = v0-1;
  left_v  = min_v;
  right_v = min_v;




  do {

      if (right_v == max_v)
        return;
      calc_right_deltas();
  } while (right_h<=0);

  do {

      if (left_v == max_v)
        return;
      calc_left_deltas();
  } while (left_h<=0);



  tex=texture;
//  zb=zbuff;

  ad=ceil(min_v->y)*screen_w;


  for (;;)
    {

        x1 = ceil(left_x);
        width = ceil(right_x) - x1;


        if (width>0)
          {

            prestep = (x1 << 16) - left_x;
            u = left_u  + imul16(prestep, du);
            v_= left_v_ + imul16(prestep, dv);
            z = left_z  + imul16(prestep, dz);

//            screen=(short *) scr;
            ad1=ad+x1;
                /*
            asm (

            "

                 pushl %%ebp;

                 movl _du,%%ebp;
                 movl _dv,%%esi;
                 movl _v_,%%ebx;
                 movl _u,%%eax;



            n_x:


                 movl %%ebx,%%edx;


                 sarl $16,%%edx;
                 sall $8,%%edx;


                 roll $16,%%eax;
                 addw %%ax,%%dx;
                 roll $16,%%eax;



                 addl %%ebp,%%eax;
                 addl %%esi,%%ebx;


                 movw _tex(%%edx,2),%%dx;
                 movw %%dx,_screen(%%edi,2);

                 incl %%edi;
                 decl %%ecx;
                 jnz n_x;

                 popl %%ebp;

                 "
             :
             : "D" ((ad+x1)), "c" (width)
             : "%eax", "%ebx", "%ecx", "%edx", "%esi", "%edi", "%ebp"
            );*/

            while (width--)
              {
                if (z>=zbuff[ad1])

                  {
                     *((short *)scr+ad1)=*( (short *)texture+ ((v_>>16)<<8) + (u>>16) );
                     zbuff[ad1]=z;
                  }


                u+=du;
                v_+=dv;
                z+=dz;

                ad1++;

              }

          }


        if (--right_h<=0)
        do {
      
            if (right_v == max_v)
              return;
            calc_right_deltas();
      
        } while (right_h<=0);

          else

        right_x+=right_dx;


        if (--left_h<=0)
        do {
      
            if (left_v == max_v)
              return;
            calc_left_deltas();
        } while (left_h<=0);

          else
        {
          left_x+=left_dx;
          left_u+=left_du;
          left_v_+=left_dv;
          left_z+=left_dz;
        }


        ad+=screen_w;



    }


}
/**/
void draw_texture_triangle_zbuffer(t2df *va,char *texture)
{
  t2df *v1=va;
  t2df *v2=va+1;
  t2df *v3=va+2;

  static t2d  vx[12];
  static t2df **dst,*t;


  double dy1,dy2;
  double d,id;
  int    i,max;

  double  ddu,ddv,ddz;


  v1->visible=cliptest(v1);
  v2->visible=cliptest(v2);
  v3->visible=cliptest(v3);

  if ( (v1->visible & v2->visible & v3->visible) != VISIBLE )
    return;



  dy1=v2->y - v3->y;
  dy2=v1->y - v3->y;

  d = (v1->x - v3->x) * dy1 -
      (v2->x - v3->x) * dy2;

  if (d == 0.0) return;

  id = 1.0/d*65536.0;

  ddu = ( (v1->u - v3->u) * dy1 - (v2->u - v3->u) * dy2 ) *id ;
  ddv = ( (v1->v - v3->v) * dy1 - (v2->v - v3->v) * dy2 ) *id ;
  ddz = ( (v1->z - v3->z) * dy1 - (v2->z - v3->z) * dy2 ) *id ;



  max=3;

  if ( ( (v1->visible | v2->visible | v3->visible) & 0xff )== VISIBLE )
    {

      fistpUVZ(&vx[0].x,&v1->x);
      fistpUVZ(&vx[1].x,&v2->x);
      fistpUVZ(&vx[2].x,&v3->x);

    }
  else
    {
      max=clip(&dst,va);
      if (max<3) return;

      for (i=0;i<max;i++)
        fistpUVZ(&vx[i].x,&dst[i]->x);
    }

  fistp(&du,&ddu);
  fistp(&dv,&ddv);
  fistp(&dz,&ddz);

  draw_texture_poly_zbuffer(vx,max,texture);


}


/**/

