#include <stdio.h>
#include <math.h>
#include <kb2.h>
#include "gfx.h"
#include "3dtypes.h"

#define R_MODE 0
#define G_MODE 1
#define B_MODE 2
#define L_MODE 3
#define N_MODE 4

#define FT_GOURAUD 0
#define FT_TEXTURE 1
#define FT_PHONG   2
#define FT_FLAT    3

#define STOSW(dest, val, numwords) \
__asm__ __volatile__ ( \
  "addl %%ebx,%%edi;" \
  "rep\n\t" \
  "stosw" \
  : : "D" (scr), "b" (dest<<1), "c" (numwords) ,"a" (val) \
  : "%ecx", "%esi", "%edi" )

#define STOSW1(dest, val) \
__asm__ __volatile__ ( \
  "addl %%ebx,%%edi;" \
  "movw %%ax,(%%edi);" \
  : : "D" (scr), "b" (dest<<1), "a" (val) \
  : "%ecx", "%esi", "%edi" )


#define WHITE COL15(0xff,0xff,0xff)

int RGB_MODE=0;


extern char *scr;
extern object obj[];
extern int obj_n;


extern int maxtex;
extern int maxpal;
extern int maxobj;

extern int TEXTURE_F;
extern int GOURAUD_F;
extern int REDRAW_F;
extern int SELECT_F;
extern int TEXTURE_GOURAUD_LIGHT;
extern int TEXTURE_PHONG_LIGHT;
extern int TEXTURE_NORMAL;
extern int TEXTURE_ENV;


extern int light[256];
extern char *light_phong_map;
extern char *texture_rgb;
extern char *background;


#define LX (640-130-1) //(512-130-1)
#define LY 0
#define HX 130
#define HY 180
/**/
void draw_small_texture(char *texture,int x,int y,int w,int h);
void make_palette(struct pal *pal);
/**/

struct menu0
  {
    char *str;
    int  value;
    int  col;
    int  bkg;
  } menu0[5]={"Red   :%d",0,0xFFFF,-1,
              "Green :%d",0,0xFFFF,-1,
              "Blue  :%d",0,0xFFFF,-1,
              "Light :%d",0,0xFFFF,-1,
              "New"      ,0,0xFFFF,-1};


static int p0=-1,p;


void display_local_menu(void)
{
  int i,c;
  static int mpos=0;

  for (i=0;i<HY;i++)
    STOSW((LY+i)*screen_w+LX,COL15(0,0,100),HX);

  for (i=0;i<11;i++)
   {
     STOSW((LY+i)*screen_w+LX,WHITE,HX+1);
     STOSW((LY+HY+i)*screen_w+LX,WHITE,HX+1);
   }


  for (i=0;i<HY;i++)
    {
      STOSW1((LY+i)*screen_w+LX,WHITE);
      STOSW1((LY+i)*screen_w+LX+HX,WHITE);
    }
  STOSW((LY+HY)*screen_w+LX,WHITE,HX);
  STOSW((LY+HY-HX+9)*screen_w+LX,WHITE,HX);

  textf(scr,LX+5,LY+02,0,"OBJ : %d",obj_n);
  textf(scr,LX+5,LY+20,WHITE,"%d faces",obj[obj_n].vertices);
  textf(scr,LX+5,LY+30,WHITE,"%d vertices",obj[obj_n].faces);

  if (key[KB_DELETE])
    {
       key[KB_DELETE]=0;

       obj[obj_n].hide=!obj[obj_n].hide;
       REDRAW_F=1;
    }

  if (key[KB_0_PAD])
    {
           key[KB_0_PAD]=0;
           if (obj[obj_n].st==FT_GOURAUD)
             if (maxtex!=0)
               obj[obj_n].st=FT_TEXTURE;
             else
               obj[obj_n].st=FT_FLAT;

           else

           if (obj[obj_n].st==FT_TEXTURE)
               obj[obj_n].st=FT_FLAT;
           else

           if (obj[obj_n].st==FT_FLAT)
               obj[obj_n].st=FT_GOURAUD;

           REDRAW_F=1;
    }


  switch (obj[obj_n].st)
    {
      case FT_FLAT:
      case FT_GOURAUD:

         textf(scr,LX+5,LY+02+HY,0,"PALETTE : %d",obj[obj_n].p);

         if (obj[obj_n].st==FT_GOURAUD)
           text(scr,LX+5,LY+40,WHITE,"GOURAUD");
         else
           text(scr,LX+5,LY+40,WHITE,"FLAT");

         p=obj[obj_n].p;

         if (p0!=p)
           {
             menu0[0].value=palette[p].r;
             menu0[1].value=palette[p].g;
             menu0[2].value=palette[p].b;
             menu0[3].value=palette[p].l;
           }
         p0=p;

         c=COL15(menu0[0].value,menu0[1].value,menu0[2].value);

         for (i=0;i<HX-10;i++)

           STOSW((LY+HY-HX+10+i)*screen_w+(LX+1),c,HX-1);


         memset(scr+(LY+HY)*screen_w*2+LX*2,WHITE,HX*2);

         menu0[mpos].col=WHITE;
         menu0[mpos].bkg=-1;

         if (key[KB_2_PAD])
           {
             key[KB_2_PAD]=0;
             mpos++;
             if (mpos>4) mpos=0;
           }
         if (key[KB_8_PAD])
           {
             key[KB_8_PAD]=0;
             mpos--;
             if (mpos<0) mpos=4;
           }

         menu0[mpos].col=0;
         menu0[mpos].bkg=WHITE;


         for (i=0;i<5;i++)
          {
            text_bkg=menu0[i].bkg;
            text(scr,LX+5,HY-HX+14+i*8,0,"          ");
            textf(scr,LX+5,HY-HX+14+i*8,menu0[i].col,
                                        menu0[i].str,
                                        menu0[i].value);
          }
         text_bkg=-1;


         if (mpos==4 && key[KB_ENTER_PAD])
           {
             key[KB_ENTER_PAD]=0;
             palette[maxpal].r=0;
             palette[maxpal].g=0;
             palette[maxpal].b=0;
             palette[maxpal].l=0;
             make_palette(&palette[maxpal]);
             obj[obj_n].p=maxpal;
             maxpal++;
             REDRAW_F=1;
           }

         if (key[KB_PLUS_PAD] )
           {

             key[KB_PLUS_PAD]=0;
             obj[obj_n].p++;
             if (obj[obj_n].p>maxpal-1) obj[obj_n].p=maxpal-1;
             REDRAW_F=1;

           }

         if (key[KB_MINUS_PAD] )
           {

             key[KB_MINUS_PAD]=0;
             obj[obj_n].p--;
             if (obj[obj_n].p<0) obj[obj_n].p=0;
             REDRAW_F=1;

           }

         if (key[KB_6_PAD])
           {
              menu0[mpos].value++;
              if (menu0[mpos].value>255) menu0[mpos].value=255;
           }
         if (key[KB_4_PAD])
           {
              menu0[mpos].value--;
              if (menu0[mpos].value<0) menu0[mpos].value=0;
           }


         if (key[KB_ENTER_PAD] && mpos!=4)
           {
             key[KB_ENTER_PAD]=0;
             palette[p].r=menu0[0].value;
             palette[p].g=menu0[1].value;
             palette[p].b=menu0[2].value;
             palette[p].l=menu0[3].value;
             make_palette(&palette[p]);
             REDRAW_F=1;
           }


         break;

      case FT_TEXTURE:

         text(scr,LX+5,LY+40,WHITE,"TEXTURE");
         textf(scr,LX+5,LY+02+HY,0,"TEXTURE : %d",obj[obj_n].t);
         draw_small_texture(texture[obj[obj_n].t].addr,LX+1,LY+HY-HX+10,HX-1,HX-10);

         if (key[KB_PLUS_PAD] )
           {

             key[KB_PLUS_PAD]=0;
             obj[obj_n].t++;
             if (obj[obj_n].t>maxtex-1) obj[obj_n].t=maxtex-1;
             REDRAW_F=1;

           }

         if (key[KB_MINUS_PAD] )
           {

             key[KB_MINUS_PAD]=0;
             obj[obj_n].t--;
             if (obj[obj_n].t<0) obj[obj_n].t=0;
             REDRAW_F=1;

           }
         if (key[KB_1])
           {
             key[KB_1]=0;
             TEXTURE_NORMAL=1;
             TEXTURE_GOURAUD_LIGHT=0;
             TEXTURE_PHONG_LIGHT=0;
             TEXTURE_ENV=0;
             REDRAW_F=1;
           }
         if (key[KB_2])
           {
             key[KB_3]=0;
             TEXTURE_NORMAL=0;
             TEXTURE_GOURAUD_LIGHT=1;
             TEXTURE_PHONG_LIGHT=0;
             TEXTURE_ENV=0;
             REDRAW_F=1;
           }
         if (key[KB_3])
           {
             key[KB_3]=0;
             TEXTURE_NORMAL=0;
             TEXTURE_GOURAUD_LIGHT=0;
             TEXTURE_PHONG_LIGHT=1;
             TEXTURE_ENV=0;
             REDRAW_F=1;
           }
         if (key[KB_4])
           {
             key[KB_4]=0;
             TEXTURE_NORMAL=0;
             TEXTURE_GOURAUD_LIGHT=0;
             TEXTURE_PHONG_LIGHT=0;
             TEXTURE_ENV=1;
             REDRAW_F=1;
           }

         break;

      case FT_PHONG:

         text(scr,LX+5,LY+40,WHITE,"PHONG");

         break;


    }
}
/**/
#define PALETTE_SIZE 256
void make_palette(struct pal *pal)
{
  float d0,c0,d1,c1,d2,c2;
  float d;
  int maxr,maxg,maxb,light;
  int i;


  maxr=pal->r;
  maxg=pal->g;
  maxb=pal->b;
  light=pal->l;

  if (!pal->addr)
    pal->addr=(short *) malloc(PALETTE_SIZE*2);

  d=(float) PALETTE_SIZE - (float) light;

  d0=(float) maxr/d;
  d1=(float) maxg/d;
  d2=(float) maxb/d;

  c0=c1=c2=0.0;

  for (i=0;i<PALETTE_SIZE-light;i++)
    {

      pal->addr[i]=COL15((int)c0,(int)c1,(int)c2);

      c0+=d0;
      c1+=d1;
      c2+=d2;
    }

  d0=(float) (PALETTE_SIZE-c0)/(float) light;
  d1=(float) (PALETTE_SIZE-c1)/(float) light;
  d2=(float) (PALETTE_SIZE-c2)/(float) light;

  for (i=PALETTE_SIZE-light;i<PALETTE_SIZE;i++)
    {

      pal->addr[i]=COL15((int)c0,(int)c1,(int)c2);

      c0+=d0;
      c1+=d1;
      c2+=d2;

    }


}
/**/
void make_gouraud_light(int l,int maxl) //maxl-natezenie swiatla
{
  float d,c;
  int i;

  for (i=0;i<PALETTE_SIZE-l;i++) light[i]=0;

  d=(float) maxl/(float) l;

  c=0.0;

  for (i=PALETTE_SIZE-l;i<PALETTE_SIZE;i++)
    {

      light[i]=(int)(c)>>3;

      c+=d;

    }


}
/**/
void make_phong_light(int maxl)
{

  int i,j,x,y,c;

  light_phong_map=(char *) malloc(256*256);
  for (i=0;i<256;i++)
    for (j=0;j<256;j++)

      {
         x=i-127;
         y=j-127;
         c=255-sqrt(x*x+y*y)*4.0;
         if (c<0) c=0;
         if (c>maxl) c=maxl;
//         *( (short*) light_phong_map+i*256+j )=COL15(c,c,c);

         *(light_phong_map+i*256+j )=c>>3;
      }

}
/**/
void make_phong(int maxl,short *phong)
{

  int i,j,x,y,c;

  phong=(short *) malloc(256*256*2);
  for (i=0;i<256;i++)
    for (j=0;j<256;j++)

      {
         x=i-127;
         y=j-127;
         c=255-sqrt(x*x+y*y)*4.0;
         if (c<0) c=0;
         if (c>maxl) c=maxl;
         *(phong+i*256+j )=COL15(c,c,c);

      }

}
/**/
void make_background(int maxl)
{

  int i,j,x,y,c;

  background=(char *) malloc(640*480*2);
  for (i=0;i<480;i++)
    for (j=0;j<640;j++)

      {
         x=i-240;
         y=j-320;
         c=255-sqrt(x*x+y*y)*4.0;
         if (c<0) c=0;
         if (c>maxl) c=maxl;
//         *( (short*) light_phong_map+i*256+j )=COL15(c,c,c);

         *((short*)background+i*640+j )=COL15(maxl-c,(int)sin(j*PI/180)*i,c);
      }

}
/**/
void make_rgb_texture(char *img)
{

  int i,j,c;
  texture_rgb=(char *) malloc(256*256*4); //32-bit r,g,b,null
  for (i=0;i<256*256;i++)
    {

      c=*( (short *) img + i);
      texture_rgb[i*4+0]=(c>>10) & 0x1f;
      texture_rgb[i*4+1]=(c>>05) & 0x1f;
      texture_rgb[i*4+2]=(c>>00) & 0x1f;
    }
}
/**/
void copyb15(char *src,char *dst,int x,int y,int w,int h)
{
  int i,j;
  int ad0,ad1;

  ad0=y*640+x;
  ad1=0;

  for (i=0;i<h;i++)
    {

///      for (j=0;j<w;j++)

   //    *( (short *) dst+ad0+j )=*( (short *) src+ad1+j );
      memcpy(&dst[ad0<<1],&src[ad1<<1],w<<1);


      ad0+=640;
      ad1+=320;
    }


}
/**/
void draw_small_texture(char *texture,int x,int y,int w,int h)
{
   int dx,dy,fx,fy;

   int i,j,adr,t,t0;

   dx=(256<<16) / w;
   dy=(256<<16) / h;

   adr=y*screen_w+x;

   fy=0;

   for (i=0;i<h;i++)
     {
       fx=0;

       t0=((fy>>16)<<8);

       for (j=0;j<w;j++)
         {

           t=t0+(fx>>16);
           *( (short *) scr+adr+j ) = *( (short *) texture+t );

           fx+=dx;
         }
       fy+=dy;
       adr+=screen_w;
     }

}
/**/
void change_texture_pixeldepth_to_16(char *texture, int w, int h)
{

  int i,j,p;

  for (i=0; i<h; i++)
    for (j=0; j<w; j++)
     {

       p = *((short *) texture + i*w+j);

       *((short *) texture + i*w+j) = COL16(GETR15(p), GETG15(p), GETB15(p));

     }


}
/**/

